package com.mints.street.ad

import android.content.Context
import com.bytedance.msdk.api.TTAdConfig
import com.bytedance.msdk.api.TTAdConstant
import com.bytedance.msdk.api.TTMediationAdSdk
import com.bytedance.msdk.api.UserInfoForSegment
import com.mints.street.BuildConfig
import com.mints.street.common.Constant
import com.mints.street.common.DeviceInfo
import java.util.*


/**
 * 描述：GroMore (包含穿山甲，快手，优量汇初始化)
 * 作者：孟崔广
 * 时间：2021/7/12 17:51
 */
object CsjGroMoreManager {

    const val TT_AD_APPID = "5198591"

    private var sInit: Boolean = false

    // gromore
    var AD_UNIT_SPLASH_ID = "887523427" // 开屏

    // 穿山甲id
    var AD_CSJ_SPLASH_ID = "887523426" // 开屏

    fun init(context: Context) {
        if (!sInit) {
            TTMediationAdSdk.initialize(context, buildConfig())
            sInit = true
        }
    }

    private fun buildConfig(): TTAdConfig {
        val userInfo = UserInfoForSegment()
        val customInfos: Map<String, String> = HashMap()
        userInfo.customInfos = customInfos
        return TTAdConfig.Builder()
                .appId(TT_AD_APPID) //必填 ，不能为空
                .appName(Constant.MINTS_APP_NAME) //必填，不能为空
                .openAdnTest(false) //开启第三方ADN测试时需要设置为true，会每次重新拉去最新配置，release 包情况下必须关闭.默认false
                .isPanglePaid(false) //是否为费用户
                .setPublisherDid(DeviceInfo.instance.iMEI) //用户自定义device_id
                .openDebugLog(BuildConfig.DEBUG) //测试阶段打开，可以通过日志排查问题，上线时去除该调用
                .usePangleTextureView(true) //使用TextureView控件播放视频,默认为SurfaceView,当有SurfaceView冲突的场景，可以使用TextureView
                .setPangleTitleBarTheme(TTAdConstant.TITLE_BAR_THEME_DARK)
                .allowPangleShowNotify(true) //是否允许sdk展示通知栏提示
                .allowPangleShowPageWhenScreenLock(true) //是否在锁屏场景支持展示广告落地页
                .setPangleDirectDownloadNetworkType(TTAdConstant.NETWORK_STATE_WIFI, TTAdConstant.NETWORK_STATE_3G) //允许直接下载的网络状态集合
                .needPangleClearTaskReset() //特殊机型过滤，部分机型出现包解析失败问题（大部分是三星）。参数取android.os.Build.MODEL
                .setUserInfoForSegment(userInfo) // 设置流量分组的信息
                .build()
    }

}