package com.mints.street.adapter

import android.content.Context
import com.alibaba.android.vlayout.LayoutHelper
import com.alibaba.android.vlayout.layout.GridLayoutHelper
import com.bumptech.glide.Glide
import com.fry.base.adapter.AbstractVLayoutBaseAdapter
import com.fry.base.adapter.BindingViewHolder
import com.fry.base.binding.setMargin
import com.mints.street.R
import com.mints.street.bean.Places
import com.mints.street.databinding.ItemGridBenfitAdpaterBinding
import com.mints.street.main.home.HomeViewModel
import me.goldze.mvvmhabit.utils.AppUtils
import me.goldze.mvvmhabit.utils.RxUtils

class GridBenfitAdapter(val context: Context, val viewMode: HomeViewModel?, places: List<Places>?) :
        AbstractVLayoutBaseAdapter<ItemGridBenfitAdpaterBinding,
                List<Places>>(context, places, 3) {

    private var datalist: List<Places>? = places
    private var mposition: Int = 0//设置首次进来默认选中第一个
    override fun onBindViewHolder(holder: BindingViewHolder<ItemGridBenfitAdpaterBinding>, position: Int) {
        //设置 view边距
        if (position % 3 == 0) {
            holder.binding.bg.setMargin(AppUtils.dp2Px(context, 20F), AppUtils.dp2Px(context, 10F),
                    AppUtils.dp2Px(context, 10F), 0, null, null, null)
        } else if (position % 3 == 1) {
            holder.binding.bg.setMargin(AppUtils.dp2Px(context, 10F), AppUtils.dp2Px(context, 10F),
                    AppUtils.dp2Px(context, 10F), 0, null, null, null)
        } else {
            holder.binding.bg.setMargin(AppUtils.dp2Px(context, 10F), AppUtils.dp2Px(context, 10F),
                    AppUtils.dp2Px(context, 20F), 0, null, null, null)
        }

        datalist?.get(position)?.apply {
            //设置图片
            Glide.with(mContext).load(images?.get(0)).into(holder.binding.imageView3)
            //设置标题
            holder.binding.textView.text = name

            //设置点击跳转
            RxUtils.onMultiClick(holder.itemView) {
                //页面跳转
//                MintsWebViewActivity.startWebView(name, url = url)
                viewMode?.authorized(name, latitude.toString(), longitude.toString(), true)
            }
        }


    }

    override fun getItemCount(): Int {
        return if (datalist == null) {
            0
        } else {
            datalist!!.size
        }
    }

    override fun getLayoutId(viewType: Int) = R.layout.item_grid_benfit_adpater

    fun getPosition() = mposition
    override fun onCreateLayoutHelper(): LayoutHelper {
        val hp: GridLayoutHelper = GridLayoutHelper(3)
        hp.setAutoExpand(false)
        return hp
    }
}


