package com.mints.street.adapter

import android.app.Application
import androidx.lifecycle.MutableLiveData
import com.google.gson.Gson
import com.mints.street.bean.AuthorizedBean
import com.mints.street.bean.BaseResponse
import com.mints.street.bean.MapBean
import com.mints.street.model.ApiModel
import com.mints.street.netwrok.base.HttpSubscribeImpl
import com.mints.street.webview.MintsWebViewActivity
import me.goldze.mvvmhabit.base.AppManager
import me.goldze.mvvmhabit.base.BaseViewModel
import me.goldze.mvvmhabit.utils.KLog
import java.io.BufferedReader
import java.io.InputStreamReader

class GridBenfitViewModel (application: Application) : BaseViewModel(application) {
    val mapBean = MutableLiveData<MapBean>()
    //0=境内 1=境外
    val index = MutableLiveData(0)
    fun getMapBean(){
        val assets = AppManager.getAppManager().currentActivity.assets
        val stringBuilder = StringBuilder()
        try {
            //通过管理器打开文件并读取
            val bf = BufferedReader(
                    InputStreamReader(
                            assets.open("map.json"))
            )
            var line: String?
            while (bf.readLine().also { line = it } != null) {
                stringBuilder.append(line)
            }
            mapBean.value = Gson().fromJson(stringBuilder.toString(), MapBean::class.java)
        } catch (e:Exception){
            KLog.e("读取assets文件下的json出问题")
        }

    }

    fun authorized(name:String?=null,lat:String?,lng:String?) {
        ApiModel.authorized().safeSubscribe(object
            : HttpSubscribeImpl<BaseResponse<AuthorizedBean>>(
                this@GridBenfitViewModel,false
        ) {
            override fun onBusinessSuccess(response: BaseResponse<AuthorizedBean>) {
                if(index.value == 0){
                    MintsWebViewActivity.startWebView(name,
                            MintsWebViewActivity.toBaduVR(lat,lng,response.result?.bk))
                }else{
                    MintsWebViewActivity.startWebView(name,
                            MintsWebViewActivity.toGoogleVR(
                                    response.result.u,
                                    response.result.gk,
                                    response.result.base,
                                    lat,
                                    lng,
                                    response.result.ut
                            ))
                }
            }

        })
    }
}
