package com.mints.street.adapter

import android.app.ActionBar
import android.content.Context
import android.icu.number.IntegerWidth
import android.view.WindowManager
import android.widget.ImageView
import com.alibaba.android.vlayout.LayoutHelper
import com.alibaba.android.vlayout.layout.GridLayoutHelper
import com.bumptech.glide.Glide
import com.fry.base.adapter.AbstractVLayoutBaseAdapter
import com.fry.base.adapter.BindingViewHolder
import com.fry.base.binding.setMargin
import com.mints.street.R
import com.mints.street.bean.VrmapBean
import com.mints.street.databinding.ItemGridMapAdapterBinding
import com.mints.street.main.vr.PanoramicActivity
import com.mints.street.webview.MintsWebViewActivity
import me.goldze.mvvmhabit.utils.AppUtils
import me.goldze.mvvmhabit.utils.KLog
import me.goldze.mvvmhabit.utils.RxUtils

/**
 * Created by 冯瑞雨 on 2021/7/9.
 */
class GridMapAdapter(val context: Context, var list: List<VrmapBean.Internal>?) :
        AbstractVLayoutBaseAdapter<ItemGridMapAdapterBinding, List<VrmapBean.Internal>>(context, list, 2) {

    override fun onBindViewHolder(
            holder: BindingViewHolder<ItemGridMapAdapterBinding>,
            position: Int
    ) {
        var a = holder.binding.bg.layoutParams
        if (position % 2 == 0) {
            holder.binding.bg.setMargin(AppUtils.dp2Px(context, 20F), AppUtils.dp2Px(context, 20F),
                    AppUtils.dp2Px(context, 15F), 0, null, null, null)
        } else {
            holder.binding.bg.setMargin(AppUtils.dp2Px(context, 15F), AppUtils.dp2Px(context, 20F),
                    AppUtils.dp2Px(context, 20F), 0, null, null, null)
        }

        list?.get(position)?.apply {
            //设置图片
            Glide.with(mContext).load(img).into(holder.binding.image)
            //设置标题
            holder.binding.tvName.text = name

            //设置点击跳转
            RxUtils.onMultiClick(holder.itemView){
                //页面跳转
                MintsWebViewActivity.startWebView(name, url = url)
            }
            holder.binding.llstart.setNumber(stars?.toInt()?:5)
        }


    }



    override fun getItemCount() = list!!.size

    override fun onCreateLayoutHelper(): LayoutHelper {
        val hp: GridLayoutHelper = GridLayoutHelper(2)
        hp.setAutoExpand(false)
        return hp
    }


    override fun getLayoutId(viewType: Int) = R.layout.item_grid_map_adapter
}