package com.mints.street.adapter

import android.content.Context
import android.graphics.Paint
import android.view.View
import com.alibaba.android.vlayout.LayoutHelper
import com.alibaba.android.vlayout.layout.GridLayoutHelper
import com.alibaba.android.vlayout.layout.LinearLayoutHelper
import com.fry.base.adapter.AbstractVLayoutBaseAdapter
import com.fry.base.adapter.BindingViewHolder
import com.fry.base.binding.setMargin
import com.mints.street.R
import com.mints.street.bean.VipBean
import com.mints.street.databinding.ItemGridPaymentAdpaterBinding
import me.goldze.mvvmhabit.utils.AppUtils

class GridPaymentAdapter(val context: Context, val list: List<VipBean.ListBean>) :
        AbstractVLayoutBaseAdapter<ItemGridPaymentAdpaterBinding,
                List<VipBean.ListBean>>(context, list, 3) {

    private var datalist: List<VipBean.ListBean>? = list
    private var mposition: Int = 0//设置首次进来默认选中第一个
    override fun onBindViewHolder(holder: BindingViewHolder<ItemGridPaymentAdpaterBinding>, position: Int) {

        holder.binding.tvOldprice.paint.flags = Paint.STRIKE_THRU_TEXT_FLAG
//        var a = holder.binding.bg.layoutParams
        //设置 view边距
        holder.binding.bg.setMargin(AppUtils.dp2Px(context, 10F), 0, AppUtils.dp2Px(context, 10F),
                AppUtils.dp2Px(context, 10F), null, null, null)


        //设置 view背景样式
        if (mposition == position) {
            holder.binding.bg.setBackgroundResource(R.drawable.shape_bg_payment_down)
        } else {
            holder.binding.bg.setBackgroundResource(R.drawable.shape_bg_payment)
        }

        //设置默认选中
        if (holder.adapterPosition == mposition) {//如果当前的view是第一个设置默认背景，并且是第一次设置背景
            holder.binding.bg.setBackgroundResource(R.drawable.shape_bg_payment_down)
        }


        //添加 套餐推荐内容
        datalist?.let {
            val databean = it[position]
//            设置点击事件
            holder.itemView.setOnClickListener {
                //设置当前段中view脚标
                mposition = holder.adapterPosition
                holder.binding.bg.setBackgroundResource(R.drawable.shape_bg_payment_down)
                notifyDataSetChanged()
            }
            holder.binding.tvDays.text = "${databean.days}天"
            holder.binding.tvOldprice.text = "原价¥${databean.oldPrice}"
            holder.binding.tvPrice.text = "¥${databean.price}"
            holder.binding.ivHot.visibility = if (databean.activityType == 0) View.GONE else View.VISIBLE
        }
    }


    override fun getItemCount(): Int {
        return if (datalist == null) {
            0
        } else {
            datalist!!.size
        }
    }


    override fun getLayoutId(viewType: Int) = R.layout.item_grid_payment_adpater

    fun getPosition() = mposition
    override fun onCreateLayoutHelper(): LayoutHelper {
        val hp: GridLayoutHelper = GridLayoutHelper(3)
        hp.setAutoExpand(false)
        return hp
    }
}


