package com.mints.street.adapter

import android.content.Context
import android.content.Intent
import android.content.pm.ActivityInfo
import android.os.UserManager
import android.view.Window
import android.view.WindowManager
import androidx.recyclerview.widget.RecyclerView
import com.alibaba.android.vlayout.LayoutHelper
import com.alibaba.android.vlayout.LayoutView
import com.alibaba.android.vlayout.layout.GridLayoutHelper
import com.fry.base.adapter.AbstractVLayoutBaseAdapter
import com.fry.base.adapter.BindingViewHolder
import com.fry.base.binding.setMargin
import com.fry.base.utils.ImageLoader
import com.mints.street.R
import com.mints.street.bean.DetailedBean
import com.mints.street.bean.UserBean
import com.mints.street.databinding.ItemGridVrmapAdapterBinding
import com.mints.street.main.my.OpenvipActivity
import com.mints.street.main.vr.DetailedActivity
import com.mints.street.main.vr.DetailedViewModel
import me.goldze.mvvmhabit.utils.AppUtils
import me.goldze.mvvmhabit.utils.RxUtils

class GridVrMapAdapter(val context: Context, var list: List<DetailedBean.DetailedItemBean>?, val viewModel: DetailedViewModel) :
        AbstractVLayoutBaseAdapter<ItemGridVrmapAdapterBinding, List<DetailedBean.DetailedItemBean>>(context, list, 2) {
    private val userManager by lazy { com.mints.street.manager.UserManager.INSTANCE }
    override fun onBindViewHolder(
            holder: BindingViewHolder<ItemGridVrmapAdapterBinding>,
            position: Int
    ) {
        var a = context.resources.displayMetrics;
        val bgLayoutParams = holder.binding.bg.layoutParams
        bgLayoutParams.height = (a.widthPixels * 0.5).toInt()
        if (position % 2 == 0) {
            holder.binding.bg.setMargin(AppUtils.dp2Px(context, 10F), AppUtils.dp2Px(context, 10F),
                    AppUtils.dp2Px(context, 6F), 0, null, null, null)
        } else {
            holder.binding.bg.setMargin(AppUtils.dp2Px(context, 6F), AppUtils.dp2Px(context, 10F), AppUtils.dp2Px(context, 10F),
                    0, null, null, null)
        }

        list?.let { it ->
            holder.binding.tvName.text = it[position].name
            ImageLoader.ImageBuilder.with(context)
                    .setUrl(it[position].img).setTargetView(holder.binding.image).start()
        }
        RxUtils.onMultiClick(holder.binding.bg) {
            if (userManager.getVipFlag()) {//是会员
                viewModel.authorized(list?.get(position)?.name, list?.get(position)?.lat, list?.get(position)?.lng)
            }else{
                context.startActivity(Intent(context, OpenvipActivity::class.java))
            }
        }
    }

    override fun getItemCount() = list?.size ?: 0

    override fun onCreateLayoutHelper(): LayoutHelper {
        val hp: GridLayoutHelper = GridLayoutHelper(2)
        hp.setAutoExpand(false)
        return hp
    }


    override fun getLayoutId(viewType: Int) = R.layout.item_grid_vrmap_adapter
}