package com.mints.street.adapter

import android.content.Context
import android.content.Intent
import com.alibaba.android.vlayout.layout.LinearLayoutHelper
import com.fry.base.adapter.AbstractVLayoutBaseAdapter
import com.fry.base.adapter.BindingViewHolder
import com.fry.base.utils.ImageLoader
import com.mints.street.R
import com.mints.street.bean.VreperienceBean
import com.mints.street.databinding.ItemEnterDestinationAdapterBinding
import com.mints.street.main.vr.DetailedActivity
import me.goldze.mvvmhabit.utils.KLog
import me.goldze.mvvmhabit.utils.RxUtils


/**
 * Created by 冯瑞雨 on 2021/7/9.
 * @param isMultipleLayout 是否是多布局
 */
class ItemEnterDestinationAdapter(
        val context: Context,
        private val isMultipleLayout: Boolean,
        var list: List<VreperienceBean.Data>?
) : AbstractVLayoutBaseAdapter<ItemEnterDestinationAdapterBinding, List<VreperienceBean.Data>?>(
        context,
        list,
        1
) {
    override fun onBindViewHolder(
            holder: BindingViewHolder<ItemEnterDestinationAdapterBinding>,
            position: Int
    ) {
        var a = context.resources.displayMetrics;
        val bgLayoutParams = holder.binding.bg.layoutParams
        if (isMultipleLayout) {
            bgLayoutParams.width = (a.widthPixels * 0.9).toInt()
        } else {
            bgLayoutParams.width = a.widthPixels
        }

        RxUtils.onMultiClick(holder.itemView
        ){
            var intent = Intent(context, DetailedActivity::class.java)
            intent.putExtra("area",list?.get(position)?.area)
            context.startActivity(intent)
        }
        list?.let { it ->
            holder.binding.tvName.text = it[position].area
            holder.binding.tvNumberPeople.text = "人数"
            it[position].url?.let { url ->
                KLog.e("zsf__","==========${it.indices}")
                for (index in 0..2) {
                    when (index) {
                        0 -> {
                            ImageLoader.ImageBuilder.with(context)
                                    .setUrl(url[index]).setTargetView(holder.binding.image3).start()
                        }
                        1 -> {
                            ImageLoader.ImageBuilder.with(context)
                                    .setUrl(url[index]).setTargetView(holder.binding.image2).start()
                        }
                        2 -> {
                            ImageLoader.ImageBuilder.with(context)
                                    .setUrl(url[index]).setTargetView(holder.binding.image1).start()

                        }
                    }
                }
            }
        }
    }

    override fun getItemCount() = list?.size ?: 0

    override fun onCreateLayoutHelper() = LinearLayoutHelper()
    override fun getLayoutId(viewType: Int) = R.layout.item_enter_destination_adapter


}
