package com.mints.street.adapter

import android.content.Context
import android.content.Intent
import android.view.View
import com.alibaba.android.vlayout.layout.LinearLayoutHelper
import com.bumptech.glide.GlideBuilder
import com.fry.base.adapter.AbstractVLayoutBaseAdapter
import com.fry.base.adapter.BindingViewHolder
import com.fry.base.utils.ImageLoader
import com.mints.street.R
import com.mints.street.bean.Places
import com.mints.street.databinding.ItemPopularSceneAdapterBinding
import com.mints.street.main.home.SearchMapViewModel
import com.mints.street.main.my.OpenvipActivity
import com.mints.street.manager.UserManager
import com.mints.street.webview.MintsWebViewActivity
import me.goldze.mvvmhabit.utils.ImageUtils
import me.goldze.mvvmhabit.utils.KLog
import me.goldze.mvvmhabit.utils.RxUtils

/**
 * Created by 冯瑞雨 on 2021/7/14.
 * 热门景区的adapter
 */
class PopularSceneAdapter(val context: Context, var list: List<Places>? = null,val viewMode: SearchMapViewModel) :
    AbstractVLayoutBaseAdapter<ItemPopularSceneAdapterBinding, List<Places>>(context, list, 2) {

    fun setData(list: List<Places>?){
        this.list = list
        notifyDataSetChanged()
    }

    override fun onBindViewHolder(
        holder: BindingViewHolder<ItemPopularSceneAdapterBinding>,
        position: Int
    ) {
        RxUtils.onMultiClick(holder.binding.bg){
            if (viewMode.index.value==0){
                viewMode.authorized(list?.get(position)?.name
                    ,list?.get(position)?.latitude.toString()
                    ,list?.get(position)?.longitude.toString())
            }else{
                if (UserManager.INSTANCE.userIsLogin()) {//是会员
                    viewMode.authorized(list?.get(position)?.name
                        ,list?.get(position)?.latitude.toString()
                        ,list?.get(position)?.longitude.toString())
                }else{
                    context.startActivity(Intent(context, OpenvipActivity::class.java))
                }

            }
        }
        holder.binding.tvName.text = list?.get(position)?.name

           when(position){
               0->{
                   holder.binding.sortIm.visibility = View.VISIBLE
                   holder.binding.sortTvName.text = ""
                   ImageLoader.ImageBuilder.with(context)
                       .setTargetView(holder.binding.sortIm)
                       .setDrawable(R.mipmap.sort_icon_1).start()
               }
               1->{
                   holder.binding.sortIm.visibility = View.VISIBLE
                   holder.binding.sortTvName.text = ""
                   ImageLoader.ImageBuilder.with(context)
                       .setTargetView(holder.binding.sortIm)
                       .setDrawable(R.mipmap.sort_icon_2).start()
               }
               2->{
                   holder.binding.sortIm.visibility = View.VISIBLE
                   holder.binding.sortTvName.text = ""
                   ImageLoader.ImageBuilder.with(context)
                       .setTargetView(holder.binding.sortIm)
                       .setDrawable(R.mipmap.sort_icon_3).start()
               }
               else->{
                   holder.binding.sortIm.visibility = View.GONE
                   holder.binding.sortTvName.text = "No.${position+1}"
               }

        }

        if(list?.get(position)?.images!=null){
            for ( index in list?.get(position)?.images!!.indices){
                if (list?.get(position)?.images?.get(index)==null)return
                when (index) {
                    0 -> {
                        ImageLoader.ImageBuilder.with(context)
                            .setUrl(list?.get(position)?.images?.get(index))
                            .setTargetView(holder.binding.image1)
                            .setCornerDp(4).start()
                    }
                    1 -> {
                        ImageLoader.ImageBuilder.with(context)
                            .setUrl(list?.get(position)?.images?.get(index))
                            .setTargetView(holder.binding.image2)
                            .setCornerDp(4).start()
                    }
                    else -> {
                        ImageLoader.ImageBuilder.with(context)
                            .setUrl(list?.get(position)?.images?.get(index))
                            .setTargetView(holder.binding.image3)
                            .setCornerDp(4).start()
                    }
                }
            }
        }
    }

    override fun getItemCount() = if (list != null) {
        list!!.size
    } else {
        0
    }

    override fun onCreateLayoutHelper() = LinearLayoutHelper()

    override fun getLayoutId(viewType: Int) = R.layout.item_popular_scene_adapter

}
