package com.mints.street.api

import com.google.gson.JsonObject
import com.mints.street.bean.BaseArrayResponse
import com.mints.street.bean.BaseResponse
import com.mints.street.bean.PositionBean
import com.mints.street.netwrok.baidu.BaiduHttpManager
import io.reactivex.Observable
import retrofit2.Response
import retrofit2.http.*


interface BaiduApi {
    companion object {
        var BAIDU_IP = "http://api.map.baidu.com/"

        fun newInstance(): BaiduApi {
            return BaiduHttpManager.getInstance().defaultClient.create(BaiduApi::class.java)
        }
    }

    /**
     * 国内
     *
     * @return
     */
    @GET("place/v2/suggestion")
    fun suggestionPlace(@Body vo: @JvmSuppressWildcards Map<String, Any>): Observable<Response<BaseResponse<Any>>>

    /**
     * 国外
     * vo["region"] = "全球"
    vo["output"] = "json"
    vo["ak"] = "tnFhCM9cTeTDZqNjRPVHbfzOz6AUPoEq"@return
     */

    @GET("place_abroad/v1/suggestion")
//    fun suggestionPlaceAbroad(@Query vo: @JvmSuppressWildcards Map<String, Any>): Observable<Response<BaseResponse<Any>>>
    fun suggestionPlaceAbroad(@Query("query") vo: String,@Query("region") vo2: String,
                              @Query("output") vo3: String,@Query("ak") vo4: String):
            Observable<Response<BaseResponse<PositionBean>>>

    @GET("place/v2/suggestion")
    fun suggestionPlaceDomestic(@Query("query") vo: String,@Query("region") vo2: String,
                              @Query("output") vo3: String,@Query("ak") vo4: String):
            Observable<Response<BaseResponse<PositionBean>>>

}