package com.mints.street.api

import com.mints.street.bean.*
import com.mints.street.netwrok.common.HttpManager
import io.reactivex.Observable
import retrofit2.Response
import retrofit2.http.Body
import retrofit2.http.POST

/**
 * Created by 冯瑞雨 on 2021/7/2.
 */
interface MainApi {
    companion object {
        fun newInstance(): MainApi {
            return HttpManager.getInstance().defaultClient.create(MainApi::class.java)
        }
    }

    /**
     * 打开激活
     *
     * @return
     */
    @POST("na/saveTerminalInfo")
    fun comSaveTerminalInfo(@Body vo: @JvmSuppressWildcards Map<String, Any>): Observable<Response<BaseResponse<Any>>>

    /**
     * 获取验证码
     *
     * @return
     */
    @POST("api/sendMobileCode")
    fun sendMobileCode(@Body vo: @JvmSuppressWildcards Map<String, Any>): Observable<Response<BaseResponse<Any>>>

    /**
     * 登录
     */
    @POST("api/mobilelogin")
    fun mobileLogin(@Body vo: @JvmSuppressWildcards Map<String, Any>): Observable<Response<BaseResponse<UserBean>>>

    /**
     * 提交设备信息
     *
     * @return
     */
    @POST("api/saveTerminalInfo")
    fun saveTerminalInfo(@Body vo: @JvmSuppressWildcards Map<String, Any>): Observable<Response<BaseResponse<Any>>>

    /**
     * 开通vip
     */
    @POST("common/getVipProductsByType")
    fun getVipProductsByType(@Body vo: @JvmSuppressWildcards Map<String, Any>): Observable<Response<BaseResponse<VipBean>>>

    /**
     * 获取vip支付渠道
     */
    @POST("common/getPayChannels")
    fun getPayChannels(@Body vo:@JvmSuppressWildcards Map<String,Any>):Observable<Response<BaseResponse<PaymentBean>>>

    /**
     * 获取支付参数
     */
    @POST("api/getVipPayParams")
    fun getVipPayParams(@Body vo:@JvmSuppressWildcards Map<String,Any>):Observable<Response<BaseResponse<WxPayParamBean>>>

    /**
     * 支付成功
     */
    @POST("api/trade/queryVipOrder")
    fun queryVipOrder(@Body vo:@JvmSuppressWildcards Map<String,Any>):Observable<Response<BaseResponse<Any>>>

    /**
     * 获取用户登录信息
     */
    @POST("api/baseMsg")
    fun baseMsg():Observable<Response<BaseResponse<UserBean>>>

    /**
     * 获取VR街景数据
     */
    @POST("na/vrPlaces")
    fun vrPlaces():Observable<Response<BaseResponse<VrmapBean>>>

    /**
     * 绑定手机号接口
     */
    @POST("api/bindingMobile")
    fun bindingMobile(@Body vo:@JvmSuppressWildcards Map<String,Any>):Observable<Response<BaseResponse<UserBean>>>

    /**
     * 获取绑定手机号验证码接口
     */
    @POST("api/sendMobileBindingCode")
    fun sendMobileBindingCode(@Body vo:@JvmSuppressWildcards Map<String,Any>):Observable<Response<BaseResponse<Any>>>

    /**
     * 微信登录
     */
    @POST("api/wechatlogin")
    fun wechatlogin(@Body vo:@JvmSuppressWildcards Map<String,Any>): Observable<Response<BaseResponse<UserBean>>>

    /**
     * 更新版本
     *
     * @return
     */
    @POST("common/checkUpgrade.do")
     fun checkUpgrade(@Body vo: @JvmSuppressWildcards Map<String
            , Any>):Observable<Response<BaseResponse<Version>>>

    /**
     * 谷歌地图授权
     *
     * @return
     */
    @POST("api/mpgah")
    fun authorized():Observable<Response<BaseResponse<AuthorizedBean>>>

    /**
     * 精选体验展示图
     */
    @POST("na/getChooseExperienceHeadData")
    fun getChooseExperienceHeadData(@Body vo:@JvmSuppressWildcards Map<String,Any>):Observable<Response<BaseResponse<VreperienceBean>>>

    /**
     * 精选体验详情
     */
    @POST("na/getChooseExperienceData")
    fun getChooseExperienceData(@Body vo:@JvmSuppressWildcards Map<String,Any>):Observable<Response<BaseResponse<DetailedBean>>>

}