package com.mints.street.bean;

import androidx.annotation.Nullable;

import com.google.gson.annotations.SerializedName;

import java.io.Serializable;
import java.util.List;

/**
 * Created by goldze on 2017/5/10.
 * 该类仅供参考，实际业务返回的固定字段, 根据需求来定义，
 */
public class BaseResponse<T> implements Serializable {
    private int status;

    private String message="";

    //    @JsonAdapter(value = JsonAdapterGsonDeserializer.class)
    @SerializedName("data")
    protected   @Nullable T result;

    @SerializedName("result")
    private @Nullable List<T> resultList;

    public BaseResponse() {
    }

    public BaseResponse(int status, String message, T result) {
        this.status = status;
        this.message = message;
        this.result = result;
    }


    public BaseResponse(int status) {
        this.status = status;
    }

    public int getstatus() {
        return status;
    }

    public void setstatus(int status) {
        this.status = status;
    }

    public T getResult() {
        return result;
    }

    public void setResult(T result) {
        this.result = result;
    }

    public boolean isOk() {
        return status == 200 || status == 0;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public void setResultList(@Nullable List<T> resultList) {
        this.resultList = resultList;
    }

    @Nullable
    public List<T> getResultList() {
        return resultList;
    }

    @Override
    public String toString() {
        return "BaseResponse{" +
                "status=" + status +
                ", message='" + message + '\'' +
                ", result=" + result +
                '}';
    }
}
