package com.mints.street.db

import androidx.room.Database
import androidx.room.Room
import androidx.room.RoomDatabase
import me.goldze.mvvmhabit.utils.Utils

/**
 * Created by 冯瑞雨 on 2021/7/20.
 */
@Database(entities = [ScenicSpotBean::class], version = 1)
abstract class AppDatabase : RoomDatabase() {
    abstract fun scenicSpotDao(): ScenicSpotDao

    companion object {
        private var _instance: AppDatabase? = null
        @JvmStatic
        fun instance(): AppDatabase {
            if (_instance == null) {
                synchronized(AppDatabase::class.java) {
                    if (_instance == null) {
                        _instance = Room.databaseBuilder(
                            Utils.getContext()
                            , AppDatabase::class.java
                            , "mints_room.com.mints.street.db")
                            .allowMainThreadQueries()//设置是否允许在主线程做查询操作
                            //.fallbackToDestructiveMigration()//设置迁移数据库如果发生错误，将会重新创建数据库，而不是发生崩溃
                            .build()
                    }
                }
            }
            return _instance!!
        }
    }
}