package com.mints.street.db

import androidx.room.ColumnInfo
import androidx.room.Entity
import androidx.room.PrimaryKey

/**
 * Created by 冯瑞雨 on 2021/7/20.
 * VR景区表
 */
@Entity(tableName = "vr_scenic_spot")
class ScenicSpotBean(
    //主键 自增
    @PrimaryKey(autoGenerate = true)
    var id: Int = 0,
    //景区 经度
    var longitude :Double?=null,
    //景区 纬度
    var latitude :Double?=null,
    //景区 名称
    var name :String? = null,
    //景区 图片
    var images : String? = null,
    //景区 url地址
    var url : String? = null,
    //景区 星级 默认0-5
    @ColumnInfo(name="star_rating")
    var starRating : String? = null
)
@Entity(tableName = "foreign_scenic_spots")
class ForeignScenicSpots(
    //主键 自增
    @PrimaryKey(autoGenerate = true)
    var id: Int = 0,
    //景区 免费还是收费的 1=免费 2=收费
    @ColumnInfo(name="is_free")
    var isFree:Int,
    //景区 经度
    var longitude :Double?=null,
    //景区 纬度
    var latitude :Double?=null,
    //景区 目的地的ID
    var did :Int?=null,
    //景区 名称
    var name :String? = null,
    //景区 人数
    @ColumnInfo(name = "number_people")
    var numberPeople :Int? = null,
    //景区 图片
    var images : List<String>? = null

)