package com.mints.street.main

import android.app.Application
import androidx.appcompat.app.AppCompatActivity
import com.google.gson.Gson
import com.mints.street.bean.BaseResponse
import com.mints.street.bean.MapBean
import com.mints.street.bean.Version
import com.mints.street.common.DeviceInfo
import com.mints.street.model.ApiModel
import com.mints.street.netwrok.base.HttpSubscribeImpl
import com.mints.street.utils.UpdateHelper
import me.goldze.mvvmhabit.base.AppManager
import me.goldze.mvvmhabit.base.BaseViewModel
import me.goldze.mvvmhabit.utils.KLog
import java.io.BufferedReader
import java.io.InputStreamReader

/**
 * Created by 冯瑞雨 on 2021/7/1.
 */
class MainViewModel(application: Application) : BaseViewModel(application) {


    fun getMapBean() {
        val assets = AppManager.getAppManager().currentActivity.assets
        val stringBuilder = StringBuilder()

        try {
            //通过管理器打开文件并读取
            val bf = BufferedReader(
                InputStreamReader(
                    assets.open("map.json")
                )
            )
            var line: String?
            while (bf.readLine().also { line = it } != null) {
                stringBuilder.append(line)
            }
            KLog.e("json", stringBuilder.toString())
            var mapBean = Gson().fromJson(stringBuilder.toString(), MapBean::class.java)


        } catch (e: Exception) {
            KLog.e("读取assets文件下的json出问题")

        }
    }

    fun checkUpgrade() {
        val vo = hashMapOf<String, Any>()
        vo["platform"] = "android"
        vo["version"] = DeviceInfo.instance.versionName
        ApiModel.checkUpgrade(lifecycleProvider, vo)
            .safeSubscribe(object
                : HttpSubscribeImpl<BaseResponse<Version>>(
                this@MainViewModel, false
            ) {
                override fun onBusinessSuccess(response: BaseResponse<Version>) {
                    response.result?.apply {
                        UpdateHelper.processUpdate(
                            AppManager.getAppManager().currentActivity as AppCompatActivity, this
                        )
                    }
                }
            })
    }
}