package com.mints.street.main.home

import android.app.Application
import android.text.TextUtils
import androidx.databinding.ObservableArrayList
import androidx.lifecycle.MutableLiveData
import com.google.gson.Gson
import com.mints.street.BR
import com.mints.street.R
import com.mints.street.bean.*
import com.mints.street.model.ApiModel
import com.mints.street.model.BaiduModel
import com.mints.street.netwrok.base.HttpSubscribeImpl
import com.mints.street.webview.MintsWebViewActivity
import me.goldze.mvvmhabit.base.AppManager
import me.goldze.mvvmhabit.base.BaseViewModel
import me.goldze.mvvmhabit.utils.KLog
import me.goldze.mvvmhabit.utils.SPUtils
import me.tatarka.bindingcollectionadapter2.ItemBinding
import java.io.BufferedReader
import java.io.InputStreamReader

/**
 * Created by 冯瑞雨 on 2021/7/13.
 */
class SearchMapViewModel(application: Application) : BaseViewModel(application) {
    //0=境内 1=境外
    val index = MutableLiveData(0)
    val positiondata: MutableLiveData<List<PositionBean>> = MutableLiveData()
    //这里是走的一个点击回调，能够打开首页进行定位
    val searchAfterItemBinding = ItemBinding.of<SearchAfterItem>(BR.viewModel, R.layout.item_search_after)
    val searchAfterOneItems = ObservableArrayList<SearchAfterItem>()
    //搜索的name
    val searchName = MutableLiveData<HistoryBean>()


    //定位位置
     val positioningBean: PositioningBean? =getpositioningMap()


    private fun getpositioningMap():PositioningBean?{
        SPUtils.getInstance(SPUtils.POSITIONING_MAP)
            .decodeString(SPUtils.POSITIONING_MAP)?.apply {
                if (!TextUtils.isEmpty(this)){
                    return  Gson().fromJson(this,PositioningBean::class.java)
                }
            }
        return null
    }


    val mapBean = MutableLiveData<MapBean>()

    fun getMapBean(){
        val assets = AppManager.getAppManager().currentActivity.assets
        val stringBuilder = StringBuilder()
        try {
            //通过管理器打开文件并读取
            val bf = BufferedReader(
                InputStreamReader(
                    assets.open("map.json"))
            )
            var line: String?
            while (bf.readLine().also { line = it } != null) {
                stringBuilder.append(line)
            }
            mapBean.value = Gson().fromJson(stringBuilder.toString(), MapBean::class.java)
        } catch (e:Exception){
            KLog.e("读取assets文件下的json出问题")
        }

    }

    /**
     * 获取国外搜索信息【通过搜索内容进行查找】
     */
    fun searchabroad(position:String) {
        BaiduModel.suggestionPlaceAbroad(lifecycleProvider
            ,position,"全球","json","tnFhCM9cTeTDZqNjRPVHbfzOz6AUPoEq")
            .safeSubscribe(
                object : HttpSubscribeImpl<BaseResponse<PositionBean>>(
                        this@SearchMapViewModel, true) {

                    override fun onBusinessSuccess(response: BaseResponse<PositionBean>) {
                        positiondata.value = response.resultList
                        println("mcg __ "+response.resultList)
                    }
                }
        )
    }

    /**
     * 获取国内搜索信息
     *  "query"" = "北京"
     *  "region"" = "中国"
     *  "output"" = "json"
     *  "ak"" = "C56Qdc560TQKtQaavS0NTPUYupsZHspI"
     */
    fun searchdomestic(position:String) {
        BaiduModel.suggestionPlaceDomestic(lifecycleProvider,position
            ,"中国","json","C56Qdc560TQKtQaavS0NTPUYupsZHspI")
            .safeSubscribe(
                object : HttpSubscribeImpl<BaseResponse<PositionBean>>(
                        this@SearchMapViewModel, true) {

                    override fun onBusinessSuccess(response: BaseResponse<PositionBean>) {
                        positiondata.value = response.resultList
                        println("mcg __ "+response.result)
                    }
                }
        )
    }
    fun authorized(name:String?=null,lat:String?,lng:String?) {
        ApiModel.authorized().safeSubscribe(object
            : HttpSubscribeImpl<BaseResponse<AuthorizedBean>>(
            this@SearchMapViewModel,false
        ) {
            override fun onBusinessSuccess(response: BaseResponse<AuthorizedBean>) {
                if(index.value == 0){
                    MintsWebViewActivity.startWebView(name,
                        MintsWebViewActivity.toBaduVR(lat,lng,response.result?.bk))
                }else{
                    MintsWebViewActivity.startWebView(name,
                        MintsWebViewActivity.toGoogleVR(
                            response.result.u,
                            response.result.gk,
                            response.result.base,
                            lat,
                            lng,
                            response.result.ut
                        ))
                }
            }

        })
    }

}