package com.mints.street.main.my

import android.graphics.Color
import android.os.Bundle
import android.view.View
import com.blankj.utilcode.util.ToastUtils
import com.bytedance.hume.readapk.HumeSDK
import com.mints.street.databinding.ActivityAboutusBinding
import com.fry.base.base.BaseActivity
import com.mints.street.AppApplication
import com.mints.street.BR
import com.mints.street.R
import com.mints.street.common.Constant
import com.mints.street.common.DeviceInfo
import com.mints.street.utils.CommonUtils
import com.mints.street.webview.MintsWebViewActivity
import kotlinx.android.synthetic.main.activity_aboutus.*
import kotlinx.android.synthetic.main.include_header.*
import me.goldze.mvvmhabit.utils.systembar.StatusBarUtil

class AboutusActivity : BaseActivity<ActivityAboutusBinding, AboutusViewModel>(), View.OnClickListener {

    override fun initVariableId() = BR.viewModel
    override fun initContentView(savedInstanceState: Bundle?) = R.layout.activity_aboutus
    override fun getStatusBarHeightView(): View? {
        return binding.tvAboutasVersion
    }
    override fun initData() {
        super.initData()
        initView()
        initListener()
    }

    private fun initListener() {
        iv_left_icon.setOnClickListener(this)
    }

    private fun initView() {
        tv_title.text = "关于我们"
        tv_title.setTextColor(Color.BLACK)
        iv_left_icon.setImageResource(R.mipmap.ic_arrow_back)
        iv_left_icon.visibility = View.VISIBLE
        tvAboutasVersion.text = "3D高清街景  v" + DeviceInfo.instance.versionName

        tvAboutasService.setOnClickListener(this)
        tvAboutasPolicy.setOnClickListener(this)

        iv_app.setOnLongClickListener {
            ToastUtils.showLong("自有渠道：" + CommonUtils.getAppMetaData(
                    AppApplication.getContext(), "CHANNEL_NAME"
            ) + "\n 头条渠道：" + HumeSDK.getChannel(AppApplication.getContext()))
            true
        }
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.iv_left_icon -> finish()
            R.id.tvAboutasService -> {
                MintsWebViewActivity.startWebView(name = "用户协议", url = Constant.REGISTER_URL)
            }
            R.id.tvAboutasPolicy -> {
                MintsWebViewActivity.startWebView(name = "隐私协议", url = Constant.PRIVACY_URL)
            }
        }
    }

}
