package com.mints.street.main.my

import android.app.Application
import androidx.lifecycle.MutableLiveData
import com.mints.street.bean.BaseResponse
import com.mints.street.bean.UserBean
import com.mints.street.manager.UserManager
import com.mints.street.model.ApiModel
import com.mints.street.netwrok.base.HttpSubscribeImpl
import me.goldze.mvvmhabit.base.BaseViewModel
import me.goldze.mvvmhabit.utils.KLog
import java.util.HashMap

class BindMobileViewModel (application: Application): BaseViewModel(application)  {


    val bindmobiledata : MutableLiveData<UserBean> = MutableLiveData()
    val data :MutableLiveData<String>  = MutableLiveData()


    /**
     * 绑定手机号验证码
     *
     * @param mobile
     */
    fun bindingMobilecode(mobile: String) {
        val vo = HashMap<String, Any>()
        vo["mobile"] = mobile

        ApiModel.bindingMobilecode(lifecycleProvider,vo).safeSubscribe(
                object : HttpSubscribeImpl<BaseResponse<Any>>(
                        this@BindMobileViewModel, true) {
                    override fun onBusinessSuccess(response: BaseResponse<Any>) {
                        KLog.e("sendMobileCode", response.result.toString())
                    }
                    override fun onError(e: Throwable) {
                        data.value  = "失败"
                        KLog.e("sendMobileCode", "绑定手机号发送验证码错误")
                    }
                })
    }

    /**
     * 绑定手机号
     */
    fun bindingMobile(mobile: String,smsCode:String){
        val vo=HashMap<String,Any>()
        vo["mobile"]=mobile
        vo["smsCode"]=smsCode
        ApiModel.bindingMobile(lifecycleProvider,vo).safeSubscribe(
                object :HttpSubscribeImpl<BaseResponse<UserBean>>(
                        this@BindMobileViewModel,true){
                    override fun onBusinessSuccess(response: BaseResponse<UserBean>) {
                        bindmobiledata.value=response.result
                        //保存用户信息到Usermanager
                        UserManager.INSTANCE.saveUserInfo(response.result)
                        KLog.e("bindingMobile",response.result.toString())
                    }

                    override fun onBusinessFail(response: BaseResponse<UserBean>?) {
                        super.onBusinessFail(response)

                    }

                    override fun onError(e: Throwable) {
                        KLog.e("bindingMobile","绑定手机号接口失败")
                    }
                }
        )
    }
}
