package com.mints.street.main.my

import android.annotation.SuppressLint
import android.app.Dialog
import android.content.Intent
import android.graphics.Color
import android.os.Bundle
import android.text.TextUtils
import android.view.KeyEvent
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import androidx.lifecycle.Observer
import com.alibaba.android.vlayout.DelegateAdapter
import com.alibaba.android.vlayout.VirtualLayoutManager
import com.cuieney.sdk.rxpay.RxPay
import com.fry.base.base.BaseActivity
import com.mints.street.BR
import com.mints.street.R
import com.mints.street.adapter.GridPaymentAdapter
import com.mints.street.bean.PaymentBean
import com.mints.street.bean.VipBean
import com.mints.street.bean.WxPayParamBean
import com.mints.street.databinding.ActivityOpenvipBinding
import com.mints.street.main.MainActivity
import com.mints.street.manager.UserManager
import com.mints.street.utils.json.JsonUtil
import com.mints.street.widget.dialog.DialogListener
import com.mints.street.widget.dialog.DialogUtils
import com.mints.street.widget.dialog.WxLoginDialog
import kotlinx.android.synthetic.main.activity_openvip.*
import kotlinx.android.synthetic.main.activity_openvip.bt_try
import kotlinx.android.synthetic.main.fragment_my.*
import kotlinx.android.synthetic.main.include_header.*
import me.goldze.mvvmhabit.base.AppManager
import me.goldze.mvvmhabit.utils.AppUtils
import me.goldze.mvvmhabit.utils.KLog
import me.goldze.mvvmhabit.utils.ToastUtils
import me.goldze.mvvmhabit.utils.systembar.StatusBarUtil


class OpenvipActivity : BaseActivity<ActivityOpenvipBinding, OpenvipViewModel>(), View.OnClickListener {

    private val userManager by lazy { UserManager.INSTANCE }
    private var vLayout: VirtualLayoutManager? = null
    private var mAdapter: DelegateAdapter? = null
    private var gridPaymentAdapter: GridPaymentAdapter? = null
    private var vipList: MutableList<VipBean.ListBean>? = null
    private var currentPayType = ""

    private val loginDialog by lazy { WxLoginDialog(this).init() }

    override fun initVariableId() = BR.viewModel
    override fun initContentView(savedInstanceState: Bundle?) = R.layout.activity_openvip

    override fun getStatusBarHeightView(): View? {
        return binding.viewBg
    }

    override fun initData() {
        super.initData()
            //获取vip福利信息
            viewModel.getVipProductsByType()
            //获取支付方式
            viewModel.getpaymentwey("android")

        initView()
        initListener()
    }

    override fun onDestroy() {
        super.onDestroy()

        loginDialog.setListener(null)
        loginDialog.onDestroy()
    }

    private fun initListener() {
        iv_left_icon.setOnClickListener(this)
        bt_try.setOnClickListener(this)
        ly_weixin.setOnClickListener(this)
        ly_alipay.setOnClickListener(this)

        loginDialog.setListener(object:WxLoginDialog.WxLoginListener{
            override fun loginSuc(wxInfo: String) {
                viewModel.wechatlogin(wxInfo)
            }
        })
    }

    @SuppressLint("InflateParams")
    private fun initView() {

        val layoutInflater = layoutInflater
        // 初始化数据
        // 初始化数据
        val list: MutableList<View> = ArrayList()
        val page1 = layoutInflater.inflate(R.layout.view_data_page1, null)
        val page2 = layoutInflater.inflate(R.layout.view_data_page2, null)
        val page3 = layoutInflater.inflate(R.layout.view_data_page3, null)
        val page4 = layoutInflater.inflate(R.layout.view_data_page4, null)
        val page5 = layoutInflater.inflate(R.layout.view_data_page5, null)
        val page6 = layoutInflater.inflate(R.layout.view_data_page6, null)
        val page7 = layoutInflater.inflate(R.layout.view_data_page7, null)
        val page8 = layoutInflater.inflate(R.layout.view_data_page8, null)

        list.add(page1)
        list.add(page2)
        list.add(page3)
        list.add(page4)
        list.add(page5)
        list.add(page6)
        list.add(page7)
        list.add(page8)

        //设置显示的数据
        cfp_data_viewpager.setViewList(list)

        //设置header样式
        tv_title.text = "成为会员"
        tv_title.setTextColor(Color.WHITE)
        iv_left_icon.setImageResource(R.mipmap.ic_arrow_back_white)
        iv_left_icon.setPadding(AppUtils.dp2Px(this, 15F), AppUtils.dp2Px(this, 15F),
                AppUtils.dp2Px(this, 15F), AppUtils.dp2Px(this, 15F))
        iv_left_icon.visibility = View.VISIBLE
        header_line.visibility = View.GONE

        //设置特权推荐
        privilege.findViewById<TextView>(R.id.tv_theme_name).text = "享8大特权"
        privilege.findViewById<TextView>(R.id.tv_me1).text = "高清地图"
        privilege.findViewById<TextView>(R.id.tv_me2).text = "国内外街景"
        privilege.findViewById<TextView>(R.id.tv_me3).text = "3D地图"
        privilege.findViewById<TextView>(R.id.tv_me4).text = "VR全景"
        privilege.findViewById<TextView>(R.id.tv_me5).text = "无限缩放"
        privilege.findViewById<TextView>(R.id.tv_me6).text = "历史影像"
        privilege.findViewById<TextView>(R.id.tv_me7).text = "国内外搜索"
        privilege.findViewById<TextView>(R.id.tv_me8).text = "景点推荐"
        privilege.findViewById<ImageView>(R.id.iv_decorate1).setImageResource(R.mipmap.icon_privilege_tiao2)
        privilege.findViewById<ImageView>(R.id.iv_decorate1).layoutParams.width = AppUtils.dp2Px(this, 100F)
        privilege.findViewById<ImageView>(R.id.iv_decorate1).layoutParams.height = AppUtils.dp2Px(this, 50F)
        privilege.findViewById<ImageView>(R.id.iv_decorate1).setPadding(0, 0, AppUtils.dp2Px(this, 50F), 0)
        privilege.findViewById<ImageView>(R.id.iv_decorate2).setImageResource(R.mipmap.icon_privilege_tiao1)
        privilege.findViewById<ImageView>(R.id.iv_decorate2).layoutParams.width = AppUtils.dp2Px(this, 100F)
        privilege.findViewById<ImageView>(R.id.iv_decorate2).layoutParams.height = AppUtils.dp2Px(this, 50F)
        privilege.findViewById<ImageView>(R.id.iv_decorate2).setPadding(AppUtils.dp2Px(this, 50F), 0, 0, 0)
        privilege.findViewById<ImageView>(R.id.iv_me1).setImageResource(R.mipmap.icon_privilege1)
        privilege.findViewById<ImageView>(R.id.iv_me2).setImageResource(R.mipmap.icon_privilege2)
        privilege.findViewById<ImageView>(R.id.iv_me3).setImageResource(R.mipmap.icon_privilege3)
        privilege.findViewById<ImageView>(R.id.iv_me4).setImageResource(R.mipmap.icon_privilege4)
        privilege.findViewById<ImageView>(R.id.iv_me5).setImageResource(R.mipmap.icon_privilege5)
        privilege.findViewById<ImageView>(R.id.iv_me6).setImageResource(R.mipmap.icon_privilege6)
        privilege.findViewById<ImageView>(R.id.iv_me7).setImageResource(R.mipmap.icon_privilege7)
        privilege.findViewById<ImageView>(R.id.iv_me8).setImageResource(R.mipmap.icon_privilege8)

        //套餐推荐
        imageView.setImageResource(R.mipmap.icon_privilege_tiao2)
        imageView.layoutParams.width = AppUtils.dp2Px(this, 80F)
        imageView.setPadding(0, 0, AppUtils.dp2Px(this, 20F), 0)
        imageView2.setImageResource(R.mipmap.icon_privilege_tiao1)
        imageView2.layoutParams.width = AppUtils.dp2Px(this, 80F)
        imageView2.setPadding(AppUtils.dp2Px(this, 20F), 0, 0, 0)

        //recycleView管理（展示套餐推荐）
        vLayout = VirtualLayoutManager(this)
        mAdapter = DelegateAdapter(vLayout, false)
        binding.listview.adapter = mAdapter
        binding.listview.layoutManager = vLayout
    }

    override fun initViewObservable() {
        super.initViewObservable()
        viewModel.Vipdata.observe(this, Observer<VipBean> {
            vipList = it.list as MutableList<VipBean.ListBean>?
            //展示 推荐套餐内容
            gridPaymentAdapter = GridPaymentAdapter(this, it.list!!)
            mAdapter?.addAdapter(gridPaymentAdapter)
        })
        viewModel.vippayParams.observe(this, Observer<WxPayParamBean> {
            if (TextUtils.equals(currentPayType, "WEIXIN")) {
                if (it == null || it.params == null) {
                    ToastUtils.showShort("微信支付维护中")
                    return@Observer
                }
                wxPay(it)
            } else {
                if (it == null || it.params == null) {
                    ToastUtils.showShort("支付宝支付维护中")
                    return@Observer
                }
                alipay(it)
            }
        })
        viewModel.isPaySuc.observe(this, Observer<Boolean> {
            if(it){
                finish()
            }
        })
        viewModel.Paymentdata.observe(this, Observer<PaymentBean> {
            if (it.list.isNullOrEmpty()) {
                return@Observer
            } else {
                //设置 默认支付方式 （根据返回参数的第一个值）
                setfirstpaymentwey(it.list!![0])

                for (str in it.list!!) {
                    if (str.equals("WEIXIN")) {
                        ly_weixin.visibility = View.VISIBLE
                        currentPayType = "WEIXIN"
                    }
                    if (str.equals("ALIPAY")) {
                        ly_alipay.visibility = View.VISIBLE
                        if (TextUtils.isEmpty(currentPayType)) {
                            currentPayType = "ALIPAY"
                        }
                    }
                }
            }

        })

    }

    override fun onKeyDown(keyCode: Int, event: KeyEvent?): Boolean {
        when (keyCode) {
            KeyEvent.KEYCODE_BACK -> {
                backvipDialog()
            }
        }
        return true
    }

    private fun setfirstpaymentwey(paymentwey: String) {
        if (paymentwey.equals("WEIXIN")) {
            setOnChecked(1)
        } else {
            setOnChecked(2)
        }
    }

    override fun onClick(v: View?) {
        when (v?.id) {
            R.id.iv_left_icon -> {
                backvipDialog()
            }
            R.id.ly_weixin -> {//微信支付
                //设置选中样式
                setOnChecked(1)
                currentPayType = "WEIXIN"
            }
            R.id.ly_alipay -> {//支付宝支付
                //设置选中样式
                setOnChecked(2)
                currentPayType = "ALIPAY"
            }
            R.id.bt_try -> {//点击开通全球会员按钮
                if (UserManager.INSTANCE.userIsLogin()) {
                    payVip()
                } else {
                    loginDialog.show()
                }
            }
        }
    }

    private fun payVip() {
        if (vipList != null && vipList!!.size > 0 && gridPaymentAdapter != null) {
            if (TextUtils.equals("WEIXIN", currentPayType)) {
                viewModel.getVipPayParams("WEIXIN", vipList!![gridPaymentAdapter!!.getPosition()].pid)
            } else {
                viewModel.getVipPayParams("ALIPAY", vipList!![gridPaymentAdapter!!.getPosition()].pid)
            }
        }
    }

    private fun backvipDialog() {
        /*DialogUtils.showbennfitsDialog(this, object : DialogListener() {
            override fun onClick(dialog: Dialog?, v: View?) {
                if (dialog != null && dialog.isShowing) {
                    dialog.dismiss()
                }
            }
        })*/
        DialogUtils.showbackvipDialog(this, object : DialogListener() {
            override fun onClick(dialog: Dialog?, v: View?) {
                if (dialog != null && dialog.isShowing) {
                    dialog.dismiss()
                }
                when (v?.id) {
                    R.id.tv_payment -> {//继续支付
                        if (UserManager.INSTANCE.userIsLogin()) {
                            payVip()
                        } else {
                            loginDialog.show()
                        }
                    }
                    R.id.tv_close -> {//取消
                        finish()
                    }
                }

            }
        })
    }

    /**
     * 设置选中支付方式view样式
     * 1--微信支付
     * 2--支付宝支付
     */
    private fun setOnChecked(paymentflag: Int?) {
        when (paymentflag) {
            1 -> {//选中微信
                iv_weixin.setImageResource(R.mipmap.pay_select)
                iv_alipay.setImageResource(R.mipmap.pay_unselect)
            }
            2 -> {//选中支付宝
                iv_weixin.setImageResource(R.mipmap.pay_unselect)
                iv_alipay.setImageResource(R.mipmap.pay_select)
            }
        }
    }


    fun wxPay(wxParanBean: WxPayParamBean) {
        val data = wxParanBean.params
        var str = "{\"prepayId\":\"${data.prepayid}\"," +
                "\"nonceStr\":\"${data.noncestr}\"," +
                "\"packageValue\":\"${data.packageX}\"," +
                "\"partnerId\":\"${data.partnerid}\"," +
                "\"sign\":\"${data.sign}\"," +
                "\"timeStamp\":\"${data.timestamp}\"}"
        RxPay(this).requestWXpay(str)
                .subscribe({ isPay ->
                    if (isPay) {
                        //支付成功
                        UserManager.INSTANCE.setVipFlag(true)
                        com.blankj.utilcode.util.ToastUtils.showShort("支付成功")
                        finish()
                    }
                }) { throwable ->
                    ToastUtils.showShort("支付异常，请联系管理员")
                }
    }

    fun alipay(wxParanBean: WxPayParamBean) {
        RxPay(this).requestAlipay(wxParanBean.params.params)
                .subscribe({ isPay ->
                    if (isPay) {
                        //支付成功
                        UserManager.INSTANCE.setVipFlag(true)
                        com.blankj.utilcode.util.ToastUtils.showShort("支付成功")
                        finish()
                    }
                }) { throwable ->
                    ToastUtils.showShort("支付异常，请联系管理员")
                }

    }

    override fun onResume() {
        super.onResume()
        KLog.e("OpenvipActivity","onResume")
//        if(userManager.userIsLogin()&&userManager.getVipFlag()){
//            finish()
//        }
    }

//    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
//        super.onActivityResult(requestCode, resultCode, data)
//        KLog.e("OpenvipActivity","onActivityResult")
//    }


}

