package com.mints.street.main.vr

import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.view.View
import android.widget.TextView
import androidx.lifecycle.Observer
import com.alibaba.android.vlayout.DelegateAdapter
import com.alibaba.android.vlayout.VirtualLayoutManager
import com.fry.base.base.BaseActivity
import com.mints.street.BR
import com.mints.street.R
import com.mints.street.adapter.GridVrMapAdapter
import com.mints.street.databinding.ActivityDetailedBinding

class DetailedActivity : BaseActivity<ActivityDetailedBinding, DetailedViewModel>(), View.OnClickListener {

    override fun initVariableId() = BR.viewModel
    override fun initContentView(savedInstanceState: Bundle?) = R.layout.activity_detailed

    private var myintent: Intent? =null
    private var vLayout: VirtualLayoutManager? = null
    private var mAdapter: DelegateAdapter? = null
    private var gridVrMapAdapter: GridVrMapAdapter? = null

    override fun initData() {
        super.initData()
        initView()
        initListener()

    }

    private fun initListener() {

    }

    private fun initView() {
        //初始化布局管理器
//        if (this == null) return
        vLayout = VirtualLayoutManager(this!!);
        mAdapter = DelegateAdapter(vLayout, false)

        binding.listview.layoutManager = vLayout
        binding.listview.adapter = mAdapter

    }


    override fun onClick(v: View?) {

    }

    override fun onResume() {
        super.onResume()
        myintent =getIntent();
        viewModel.getChooseExperienceData(myintent?.getStringExtra("area")!!)
    }

    override fun initViewObservable() {
        super.initViewObservable()
        viewModel.detailbean.observe(this, Observer {
            if (gridVrMapAdapter == null){
                gridVrMapAdapter =  GridVrMapAdapter(this, it.list,viewModel)
                mAdapter?.addAdapter(gridVrMapAdapter)
            }
            gridVrMapAdapter?.list = it.list
            mAdapter?.notifyDataSetChanged()
            binding.tvIntroduce.text=it.desc
            binding.tvName.text=myintent?.getStringExtra("area")!!
        })
    }
}