package com.mints.street.main.vr

import android.app.Application
import androidx.lifecycle.MutableLiveData
import com.mints.street.bean.AuthorizedBean
import com.mints.street.bean.BaseResponse
import com.mints.street.bean.DetailedBean
import com.mints.street.model.ApiModel
import com.mints.street.netwrok.base.HttpSubscribeImpl
import com.mints.street.webview.MintsWebViewActivity
import me.goldze.mvvmhabit.base.BaseViewModel
import me.goldze.mvvmhabit.utils.KLog
import java.util.HashMap

class DetailedViewModel(application: Application) : BaseViewModel(application) {

    val detailbean: MutableLiveData<DetailedBean> = MutableLiveData()


    fun getChooseExperienceData(name:String){
        val vo = HashMap<String, Any>()
        vo["area"] = name
        ApiModel.getChooseExperienceData(lifecycleProvider,vo).safeSubscribe(
                object : HttpSubscribeImpl<BaseResponse<DetailedBean>>(
                        this@DetailedViewModel,true){
                    override fun onBusinessSuccess(response: BaseResponse<DetailedBean>) {
                        detailbean.value=response.result
                        KLog.e("getChooseExperienceData","成功=================")
                    }

                    override fun onError(e: Throwable) {
                        KLog.e("getChooseExperienceData","请求失败 : $e")
                    }
                }
        )
    }
    fun authorized(name:String?,lat:Double?=0.0 ,lng:Double?=0.0) {
        ApiModel.authorized().safeSubscribe(object
            : HttpSubscribeImpl<BaseResponse<AuthorizedBean>>(
            this@DetailedViewModel,false
        ) {
            override fun onBusinessSuccess(response: BaseResponse<AuthorizedBean>) {
                MintsWebViewActivity.startWebView(
                    name,
                    MintsWebViewActivity.toGoogleVR(
                        response.result.u,
                        response.result.gk,
                        response.result.base,
                        lat.toString(),
                        lng.toString(),
                        response.result.ut
                    )
                )
            }

        })
    }
}
