package com.mints.street.main.vr

import android.os.Bundle
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.lifecycle.Observer
import com.alibaba.android.vlayout.DelegateAdapter
import com.alibaba.android.vlayout.VirtualLayoutManager
import com.fry.base.base.BaseFragment
import com.mints.street.BR
import com.mints.street.R
import com.mints.street.adapter.ItemEnterDestinationAdapter
import com.mints.street.databinding.FragmentFeaturedExperienceBinding

/**
 * Created by 冯瑞雨 on 2021/7/9.
 * 精选体验
 */
class FeaturedExperienceFragment:BaseFragment<FragmentFeaturedExperienceBinding
        ,FeaturedExperienceViewModel>() {

    private var vLayout: VirtualLayoutManager? = null
    private var mAdapter: DelegateAdapter? = null
    private var itemEnterDestinationAdapter:ItemEnterDestinationAdapter?=null
    override fun initContentView(
        inflater: LayoutInflater?,
        container: ViewGroup?,
        savedInstanceState: Bundle?
    )= R.layout.fragment_featured_experience

    override fun initVariableId() = BR.viewModel

    override fun initData() {
        super.initData()
        //初始化布局管理器
        if (context ==null)return
        vLayout =  VirtualLayoutManager(context!!);
        mAdapter = DelegateAdapter(vLayout,false)

        binding.listView.layoutManager = vLayout
        binding.listView.adapter = mAdapter
        binding.srlMy.setOnRefreshListener {
            //获取VR全景数据
            viewModel.getChooseExperienceHeadData()
        }
        viewModel.getChooseExperienceHeadData()

    }

    override fun initViewObservable() {
        super.initViewObservable()

        viewModel.VreperienceBean.observe(this, Observer {

            binding.srlMy.finishRefresh(true)

//            mAdapter?.addAdapter(ItemEnterDestinationAdapter(context!!, false,it.abroad))
            if (itemEnterDestinationAdapter == null){
                itemEnterDestinationAdapter =  ItemEnterDestinationAdapter(context!!, false, it.data)
                mAdapter?.addAdapter(itemEnterDestinationAdapter)
            }
            itemEnterDestinationAdapter?.list = it.data!!
            mAdapter?.notifyDataSetChanged()
        })
    }
}