package com.mints.street.main.vr

import android.os.Bundle
import android.view.LayoutInflater
import android.view.ViewGroup
import androidx.lifecycle.Observer
import com.alibaba.android.vlayout.DelegateAdapter
import com.alibaba.android.vlayout.VirtualLayoutManager
import com.fry.base.base.BaseFragment
import com.mints.street.BR
import com.mints.street.R
import com.mints.street.adapter.EnterDestinationAdapter
import com.mints.street.adapter.GridMapAdapter
import com.mints.street.bean.VrmapBean
import com.mints.street.databinding.FragmentFreeZoneBinding
import com.scwang.smartrefresh.layout.api.RefreshLayout
import com.scwang.smartrefresh.layout.listener.OnRefreshListener
import me.goldze.mvvmhabit.utils.KLog

/**
 * Created by 冯瑞雨 on 2021/7/9.
 * 免费专区
 */
class FreeZoneFragment : BaseFragment<FragmentFreeZoneBinding, FreeZoneViewModel>() {
    private var vLayout: VirtualLayoutManager? = null
    private var mAdapter: DelegateAdapter? = null
    private var gridMapAdapter: GridMapAdapter? = null
    //private var enterDestinationAdapter: EnterDestinationAdapter? = null

    override fun initContentView(
            inflater: LayoutInflater?,
            container: ViewGroup?,
            savedInstanceState: Bundle?
    ) = R.layout.fragment_free_zone

    override fun initVariableId() = BR.viewModel


    override fun initData() {
        super.initData()

        //初始化布局管理器
        if (context == null) return
        vLayout = VirtualLayoutManager(context!!);
        mAdapter = DelegateAdapter(vLayout, false)

        binding.listView.layoutManager = vLayout
        binding.listView.adapter = mAdapter
        binding.srlMy.autoRefresh()//自动刷新
        binding.srlMy.setOnRefreshListener {
            //获取VR全景数据
            viewModel.vrPlaces()
        }
        viewModel.vrPlaces()

    }

    override fun initViewObservable() {
        super.initViewObservable()
        viewModel.VrmapBean.observe(this, Observer<VrmapBean> {
            binding.srlMy.finishRefresh(true)

//            if(enterDestinationAdapter == null){
//                enterDestinationAdapter = EnterDestinationAdapter(context!!,it.abroad )
//                mAdapter?.addAdapter(enterDestinationAdapter)
//            }
            if (gridMapAdapter == null){
                gridMapAdapter =  GridMapAdapter(context!!, it.internal)
                mAdapter?.addAdapter(gridMapAdapter)
            }
            gridMapAdapter?.list = it.internal
            mAdapter?.notifyDataSetChanged()
        })
    }

}