package com.mints.street.main.vr

import android.app.Application
import androidx.lifecycle.MutableLiveData
import com.mints.street.bean.BaseResponse
import com.mints.street.bean.VrmapBean
import com.mints.street.db.ScenicSpotBean
import com.mints.street.model.ApiModel
import com.mints.street.netwrok.base.HttpSubscribeImpl
import me.goldze.mvvmhabit.base.BaseViewModel
import me.goldze.mvvmhabit.utils.KLog

/**
 * Created by 冯瑞雨 on 2021/7/9.
 */
class FreeZoneViewModel(application: Application):BaseViewModel(application) {

    //获取vr街景数据
    val VrmapBean: MutableLiveData<VrmapBean> = MutableLiveData()
    fun vrPlaces(){//无参数传递
        ApiModel.vrPlaces(lifecycleProvider).safeSubscribe(
                object : HttpSubscribeImpl<BaseResponse<VrmapBean>>(
                        this@FreeZoneViewModel,true){
                    override fun onBusinessSuccess(response: BaseResponse<VrmapBean>) {
                        VrmapBean.value=response.result
                        val a:MutableList<ScenicSpotBean> = ArrayList()
                        for (item in response.result.internal!!){
                            a.add(ScenicSpotBean(name = item.name,url = item.url
                                ,starRating = item.stars,images = item.img))
                        }
//                        AppDatabase.instance().scenicSpotDao().addVRFreeZoneAll(a)
//                        for(item in AppDatabase.instance().scenicSpotDao().getVRFreeZoneAll()){
//                            KLog.e("AppDatabase.instance().scenicSpotDao().getVRFreeZoneAll()",item.toString())
//                        }
                    }

                    override fun onError(e: Throwable) {
                        KLog.e("vrPlaces","请求失败 : $e")
                    }
                }
        )
    }
}