package com.mints.street.manager

import com.umeng.analytics.MobclickAgent
import com.umeng.commonsdk.UMConfigure
import com.mints.street.BuildConfig
import com.mints.street.AppApplication
import com.mints.street.utils.CommonUtils

object UmengManager {

    fun preInit(){
        UMConfigure.preInit(AppApplication.getContext(), CommonUtils.getAppMetaData(AppApplication.getContext(), "UMENG_KEY"),
                CommonUtils.getAppMetaData(AppApplication.getContext(), "CHANNEL_NAME"))
    }

    /**
     * 友盟初始化
     */
    fun initUm() {
        try {
            /*
             * 参数4:设备类型，必须参数，传参数为UMConfigure.DEVICE_TYPE_PHONE则表示手机；传参数为UMConfigure.DEVICE_TYPE_BOX则表示盒子；默认为手机。
             * 参数5:Push推送业务的secret，需要集成Push功能时必须传入Push的secret，否则传空。
             */
            UMConfigure.init(
                    AppApplication.getContext(),
                    CommonUtils.getAppMetaData(AppApplication.getContext(), "UMENG_KEY"),
                    CommonUtils.getAppMetaData(AppApplication.getContext(), "CHANNEL_NAME"),
                    UMConfigure.DEVICE_TYPE_PHONE,
                    ""
            )
            UMConfigure.setLogEnabled(BuildConfig.DEBUG)
            MobclickAgent.setPageCollectionMode(MobclickAgent.PageMode.LEGACY_MANUAL)
        } catch (e: java.lang.Exception) {
            e.printStackTrace()
        }
    }
}