package com.mints.street.model

import com.mints.street.api.MainApi
import com.mints.street.bean.*
import com.mints.street.netwrok.common.HttpManager
import com.trello.rxlifecycle2.LifecycleProvider
import io.reactivex.Observable
import retrofit2.Response
import retrofit2.http.Body

/**
 * Created by 冯瑞雨 on 2021/7/2.
 */
object ApiModel {

    /**
     * 打开激活
     */
    fun comSaveTerminalInfo(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>): Observable<Response<BaseResponse<Any>>> {
        return HttpManager.getInstance()
                .execute(lifecycleProvider, MainApi.newInstance().comSaveTerminalInfo(map))
    }

    /**
     * 发送验证码
     */
    fun sendMobileCode(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>): Observable<Response<BaseResponse<Any>>> {
        return HttpManager.getInstance()
                .execute(lifecycleProvider, MainApi.newInstance().sendMobileCode(map))
    }

    /**
     * 登录
     */
    fun login(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>): Observable<Response<BaseResponse<UserBean>>> {
        return HttpManager.getInstance()
                .execute(lifecycleProvider, MainApi.newInstance().mobileLogin(map))
    }

    /**
     * 设备信息
     */
    fun saveTerminalInfo(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>): Observable<Response<BaseResponse<Any>>> {
        return HttpManager.getInstance()
                .execute(lifecycleProvider, MainApi.newInstance().saveTerminalInfo(map))
    }


    /**
     * 开通会员
     */
    fun getVipProductsByType(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>): Observable<Response<BaseResponse<VipBean>>> {
        return HttpManager.getInstance()
                .execute(lifecycleProvider, MainApi.newInstance().getVipProductsByType(map))
    }

    /**
     * 获取开通vip支付方式
     */
    fun getpaymentwey(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>): Observable<Response<BaseResponse<PaymentBean>>> {
        return HttpManager.getInstance()
                .execute(lifecycleProvider, MainApi.newInstance().getPayChannels(map))
    }

    /**
     * 获取支付参数
     */
    fun getVipPayParams(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>): Observable<Response<BaseResponse<WxPayParamBean>>> {
        return HttpManager.getInstance()
                .execute(lifecycleProvider, MainApi.newInstance().getVipPayParams(map))
    }

    /**
     * 支付成功
     */
    fun queryVipOrder(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>): Observable<Response<BaseResponse<Any>>> {
        return HttpManager.getInstance()
                .execute(lifecycleProvider, MainApi.newInstance().queryVipOrder(map))
    }

    /**
     * 获取用户登录信息
     */
    fun getuserInfo(lifecycleProvider: LifecycleProvider<Any>?): Observable<Response<BaseResponse<UserBean>>> {
        return HttpManager.getInstance()
                .execute(lifecycleProvider, MainApi.newInstance().baseMsg())
    }

    /**
     * 获取VR街景数据
     */
    fun vrPlaces(lifecycleProvider: LifecycleProvider<Any>?):Observable<Response<BaseResponse<VrmapBean>>>{
        return HttpManager.getInstance()
                .execute(lifecycleProvider,MainApi.newInstance().vrPlaces())
    }

    /**
     * 精选体验展示图
     */
    fun getChooseExperienceHeadData(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>):Observable<Response<BaseResponse<VreperienceBean>>>{
        return HttpManager.getInstance().execute(lifecycleProvider,MainApi.newInstance().getChooseExperienceHeadData(map))
    }

    /**
     * 精选体验详情
     */
    fun getChooseExperienceData(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>):Observable<Response<BaseResponse<DetailedBean>>>{
        return HttpManager.getInstance().execute(lifecycleProvider,MainApi.newInstance().getChooseExperienceData(map))
    }
    /**
     * 绑定手机号登录
     */
    fun bindingMobile(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>):Observable<Response<BaseResponse<UserBean>>>{
        return HttpManager.getInstance().execute(lifecycleProvider,MainApi.newInstance().bindingMobile(map))
    }

    /**
     * 获取绑定手机号验证码
     */
    fun bindingMobilecode(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>):Observable<Response<BaseResponse<Any>>>{
        return HttpManager.getInstance().execute(lifecycleProvider,MainApi.newInstance().sendMobileBindingCode(map))
    }

    /**
     * 微信登录
     */
    fun wechatlogin(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>):Observable<Response<BaseResponse<UserBean>>>{
        return HttpManager.getInstance().execute(lifecycleProvider,MainApi.newInstance().wechatlogin(map))
    }
    /**
     * 更新版本
     */
    fun checkUpgrade(lifecycleProvider: LifecycleProvider<Any>?, map: Map<String, Any>):Observable<Response<BaseResponse<Version>>>{
        return HttpManager.getInstance().execute(lifecycleProvider,MainApi.newInstance().checkUpgrade(map))
    }
    /**
     * 谷歌地图授权
     */
    fun authorized():Observable<Response<BaseResponse<AuthorizedBean>>>{
        return HttpManager.getInstance().execute(null,MainApi.newInstance().authorized())
    }
}