package com.mints.street.netwrok.base;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import okhttp3.Interceptor;

/**
 * Created by jeme on 2019/1/31
 */
public class HttpConfiguation {

    //超时时间
    private int mDefaultTimeOut = 30;
    //缓存时间
    private int mDefaultCacheTimeOut = 10 * 1024 * 1024;
    //服务端根路径
    private String mBaseUrl;
    //缓存文件名
    private String mCacheDirName;
    //http head
    private Map<String, String> mHeaders;
    //拦截器
    private List<Interceptor> mInterceptor = new ArrayList<>();

    private HttpConfiguation() {
    }

    public static HttpConfiguation create(String baseUrl){
        HttpConfiguation thiz = new HttpConfiguation();
        thiz.setBaseUrl(baseUrl);
        return thiz;
    }

    public HttpConfiguation setBaseUrl(String baseUrl){
        mBaseUrl = baseUrl;
        return this;
    }
    public String getBaseUrl(){
        return mBaseUrl;
    }
    public HttpConfiguation setCacheDirName(String cacheDirName){
        mCacheDirName = cacheDirName;
        return this;
    }
    public String getCacheDirName(){
        return mCacheDirName;
    }

    public HttpConfiguation setTimeOut(int timeOut){
        mDefaultTimeOut = timeOut;
        return this;
    }
    public HttpConfiguation setCacheDirName(int timeOut){
        mDefaultCacheTimeOut = timeOut;
        return this;
    }
    public int getTimeOut(){
        return mDefaultTimeOut;
    }
    public int getCacheTimeOut(){
        return mDefaultCacheTimeOut;
    }
    public HttpConfiguation setHeads(Map<String,String> heads){
        if(mHeaders == null){
            mHeaders = heads;
        }else {
            mHeaders.putAll(heads);
        }
        return this;
    }
    public Map<String,String> getHeads(){
        return mHeaders;
    }

    public HttpConfiguation addInterceptor(Interceptor interceptor){
        mInterceptor.add(interceptor);
        return this;
    }
    public List<Interceptor> getInterceptors(){
        return mInterceptor;
    }


}
