package com.mints.street.netwrok.base;

import com.mints.street.bean.BaseResponse;

import io.reactivex.disposables.Disposable;
import me.goldze.mvvmhabit.http.ResponseThrowable;
import retrofit2.Response;

/**
 * Created by jeme on 2019/1/31
 */
public interface IHttpResponseListener<T extends BaseResponse> {

    void onStart(Disposable disposable);

    /***
     * @return true 不执行onBusinessSuccess或onBusinessFail
     */
    boolean onParseResponse(Response<T> response);
    void onBusinessSuccess(T response);
    void onBusinessFail(T response);
    void onFailed(ResponseThrowable throwable);
    void onCompleted();
}
