package com.mints.street.netwrok.base

import com.mints.street.bean.BaseResponse
import io.reactivex.Observer
import io.reactivex.disposables.Disposable
import me.goldze.mvvmhabit.base.BaseViewModel
import retrofit2.Response

/**
 *
 * @author jeme
 * @date 2020/1/10
 */

abstract class IHttpSubscribe<T : BaseResponse<*>>(val viewModel: BaseViewModel?) : Observer<Response<T>> {
    companion object {
        private val requestMap = HashMap<String, Boolean>()
    }
    protected var isBusinessSuccess : Boolean = false

    protected var disposable: Disposable? = null
    open fun getTag(): String? {
        return null
    }

    private fun getHttpLoading(): Boolean {
        return requestMap[getTag() ?: ""] ?: false
    }

    private fun setHttpLoading(isLoading: Boolean) {
        getTag()?.apply {
            if (isLoading) {
                requestMap[this] = true
            } else {
                requestMap.remove(this)
            }

        }
    }

    override fun onComplete() {
        viewModel?.dismissDialog()
        setHttpLoading(false)
    }

    override fun onSubscribe(d: Disposable) {
//        viewModel?.showDialog()
        val isLoading = getHttpLoading()
        disposable = d
        if (!isLoading) {
            viewModel?.showDialog()
            setHttpLoading(true)
        } else {
            d.dispose()
            viewModel?.dismissDialog()
        }
    }

    override fun onError(e: Throwable) {
        viewModel?.dismissDialog()
        setHttpLoading(false)
    }

}