package com.mints.street.utils;

import android.content.Context;
import android.os.Build;
import android.os.Environment;
import android.text.TextUtils;

import com.lxj.xpopup.interfaces.OnConfirmListener;
import com.mints.street.bean.Version;
import com.mints.street.widget.dialog.UpdateDialog;

import java.io.File;

import androidx.appcompat.app.AppCompatActivity;
import me.goldze.mvvmhabit.utils.AppUtils;
import me.goldze.mvvmhabit.utils.CommonDialogUtils;

/**
 * @author jeme
 */
public class UpdateHelper {

    /***
     * 普通升级
     */
    public static final int UPDATE = 1;
    /***
     * 强制升级
     */
    public static final int FORCE_UPDATE = 2;

    /***
     * 处理升级功能
     */
    public static void processUpdate(AppCompatActivity appCompatActivity, Version version) {
            UpdateDialog.showDialog(appCompatActivity, version);
    }

    /***
     * 检查升级文件合法性
     */
    public static boolean checkUpdateFile(Context context, String appVersionCode, String md5) {
        if (TextUtils.isEmpty(md5)) {
            return false;
        }
        String dir = getDownloadDir(context);
        File file = new File(String.format("%s%s%s", dir, File.separator, appVersionCode));
        if (file.exists()) {
            String md5_ = me.goldze.mvvmhabit.utils.FileUtils.getFileMD5(file);
            return TextUtils.equals(md5, md5_);
        }
        return false;
    }

    public static String getDownloadDir(Context context) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.Q) {
            return context.getExternalFilesDir(Environment.DIRECTORY_DOWNLOADS).getPath();
        } else {
            return Environment.getExternalStorageDirectory().getPath();
        }
    }

    public static String getFileName(String newVersionCode) {
        return String.format("last-%s.apk", newVersionCode);
    }

    private static void showInstallDialog(AppCompatActivity activity, String appVersion) {
        CommonDialogUtils.showMessage(activity, "安装", "新包已经下载成功，是否直接安装?", "确定", "取消", new OnConfirmListener() {
            @Override
            public void onConfirm() {
                AppUtils.installApk(activity,
                        String.format("%s%s%s", getDownloadDir(activity),
                                File.separator, getFileName(appVersion)));
            }
        },null,false);
     /*   TDialogHelper.selectDialog(activity,"安装","新包已经下载成功，是否直接安装?")
                .setOnViewClickListener(new OnViewClickListener() {
                    @Override
                    public void onViewClick(BindViewHolder viewHolder, View view, TDialog tDialog) {
                        if(view.getId() == R.id.tv_confirm){
                            AppUtils.installApk(activity,
                                    String.format("%s%s%s",getDownloadDir(activity),
                                            File.separator,getFileName(appVersion)));
                        }
                        tDialog.dismiss();
                    }
                }).create().show();*/

    }
}
