package com.mints.street.webview

import android.content.Intent
import android.os.Bundle
import android.view.ViewGroup
import android.webkit.WebChromeClient
import android.webkit.WebView
import android.webkit.WebViewClient
import com.fry.base.base.BaseActivity
import com.github.lzyzsd.jsbridge.CallBackFunction
import com.github.lzyzsd.jsbridge.DefaultHandler
import com.lxj.xpopup.interfaces.OnConfirmListener
import com.mints.street.BR
import com.mints.street.R
import com.mints.street.databinding.ActivityMintsWebViewBinding
import me.goldze.mvvmhabit.base.AppManager
import me.goldze.mvvmhabit.utils.CommonDialogUtils.Companion.showMessage
import me.goldze.mvvmhabit.utils.KLog

/**
 * Created by 冯瑞雨 on 2021/7/15.
 */
class MintsWebViewActivity : BaseActivity<ActivityMintsWebViewBinding, MintsWebViewModel>() {

    companion object{
        fun startWebView(name:String?=null,url:String?=null){
            AppManager.getAppManager().currentActivity?.apply {
                val intent = Intent(this,MintsWebViewActivity::class.java)
                intent.putExtra("name",name)
                intent.putExtra("url",url)
                this.startActivity(intent)
            }
        }
        fun toGoogleVR(u:String?,gk:String?,base:String?,lat:String?,lng:String?,ut:String?):String{
            KLog.i("MintsWebViewActivity","file:///android_asset/web/streets.html?u=${u
            }&gk=${gk}&base=${base}&lat=${lat}&lng=${lng}&ut=${ut}")
            return "file:///android_asset/web/streets.html?u=${u
            }&gk=${gk}&base=${base}&lat=${lat}&lng=${lng}&ut=${ut}"
        }
        fun toBaduVR(d:String?,bk:String?):String{
            KLog.i("MintsWebViewActivity","file:///android_asset/web/mr.html?d=${d}&bk=${bk}")
            return "file:///android_asset/web/m.html?d=${d}&bk=${bk}"
        }
        fun toBaduVR(lat:String?,lng:String?,bk:String?):String{

            KLog.i("MintsWebViewActivity","file:///android_asset/web/m.html?lat=${lat}&lng=${lng}&bk=${bk}")
            return "file:///android_asset/web/m.html?lat=${lat}&lng=${lng}&bk=${bk}"
        }
    }
    override fun initContentView(savedInstanceState: Bundle?) = R.layout.activity_mints_web_view

    override fun initVariableId() = BR.viewModel

    override fun initData() {
        super.initData()
        binding.ctbTitle.setTitle(intent.getStringExtra("name"))
       if(intent.getStringExtra("url")!=null && "" != intent.getStringExtra("url")){
           binding.webview.loadUrl(intent.getStringExtra("url")?:"")
       }

        binding.webview.webViewClient = object : WebViewClient() {
            override fun shouldOverrideUrlLoading(view: WebView?, url: String?): Boolean {
                KLog.i("MintsWebViewActivity",url)
                //使用WebView加载显示url
                if (url != null) {
                    view?.loadUrl(url)
                    return true
                } else {
                    return false
                }
            }
        }
        binding.webview.setDefaultHandler(DefaultHandler())
        binding.webview.webChromeClient = WebChromeClient()
        binding.webview.setOnLongClickListener { true }

        binding.webview.setDefaultHandler(object : DefaultHandler() {
            override fun handler(data: String, function: CallBackFunction) {
                showMessage(AppManager.getAppManager().currentActivity
                    ,content = data,confirmListener = OnConfirmListener{

                })
            }
        })



    }

    override fun onDestroy() {
        super.onDestroy()

        binding.webview.let {
            it.destroyDrawingCache()
            val parent = it.parent as ViewGroup
            parent?.removeView(it)
            it.removeAllViews()
            it.destroy()
        }
    }
}