package com.mints.street.widget;

import android.content.Context;
import android.content.res.TypedArray;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.util.AttributeSet;
import android.view.MotionEvent;
import android.view.View;

import com.mints.street.R;

import androidx.annotation.Nullable;

/**
 * Created by 冯瑞雨 on 2021/7/21.
 */
public class RatingStar extends View {

    private int normalId;
    private Bitmap normalImg;
    private Bitmap focusImg;
    private int number;
    private int w1;
    private int h1;
    private int marginLeft;
    private int marginTop;
    private int marginBottom;
    private int marginRight;
    private int height;
    private int width;
    private int p;
    private float w0;
    private int i0;
    private int mGrade;

    public RatingStar(Context context) {
        this(context,null);
    }

    public RatingStar(Context context, @Nullable AttributeSet attrs) {
        this(context, attrs,0);
    }

    public RatingStar(Context context, @Nullable AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
        TypedArray array = context.obtainStyledAttributes(attrs, R.styleable.RatingStar);
        normalId = array.getResourceId(R.styleable.RatingStar_starNormal,0);
        normalImg = BitmapFactory.decodeResource(getResources(), normalId);
        number = array.getInteger(R.styleable.RatingStar_starNumber,5);
        array.recycle();
        i0 = -1;

    }
    public void setNumber(int number){
        this.number = number;
    }

    @Override
    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
        w1 = normalImg.getWidth();
        h1 = normalImg.getHeight();
        //中间间隔
        p = 10;
//        marginTop = 20;
//        marginBottom = 20;
//        marginLeft = 20;
//        marginRight = 20;
        height = h1 + marginTop + marginBottom;
        width = w1 *number+(number-1)*p +marginLeft+marginRight;
        setMeasuredDimension(width, height);
    }

    @Override
    protected void onDraw(Canvas canvas) {
        super.onDraw(canvas);
        for (int i = 0; i < number; i++) {
            if (i <= i0){
                canvas.drawBitmap(focusImg,i*w1+marginLeft+i*p,marginTop,null);
                mGrade = i+1;
            }else{
                canvas.drawBitmap(normalImg,i*w1+marginLeft+i*p,marginTop,null);
            }
        }
       // Log.e("msg","我被调用了！");
    }

}