package com.mints.street.widget.dialog


import android.app.Dialog
import android.content.Context
import android.text.Html
import android.view.Gravity
import android.view.KeyEvent
import android.view.WindowManager
import android.widget.ImageView
import android.widget.TextView
import com.mints.street.R

/**
 * 确认取消支付弹窗
 */
class BackVipDialog(context: Context, private val listener: DialogListener) :
        Dialog(context, R.style.dialog) {
    private val lp: WindowManager.LayoutParams

    private val tv_payment: TextView
    private val tv_close: ImageView

    init {
        setContentView(R.layout.dialog_backvip)
        // 设置window属性
        lp = window!!.attributes
        lp.gravity = Gravity.CENTER
        lp.width = WindowManager.LayoutParams.WRAP_CONTENT
        lp.windowAnimations = R.style.DialogAnimBottom
        window!!.attributes = lp

        // 设置外部不可关闭
        setCancelable(false)
        setCanceledOnTouchOutside(false)
        setOnKeyListener { _, i, _ ->
            i == KeyEvent.KEYCODE_BACK
        }
        // 查找View
        tv_payment = findViewById(R.id.tv_payment)
        tv_close = findViewById(R.id.tv_close)


        tv_payment.setOnClickListener {
            listener.onClick(it)
        }
        tv_close.setOnClickListener {
            listener.onClick(it)
        }
    }
}