package com.mints.street.widget.dialog

import android.app.AlertDialog
import android.content.Context
import android.content.DialogInterface
import android.content.Intent
import android.net.Uri
import android.provider.Settings
import com.mints.street.adapter.GridBenfitViewModel
import com.mints.street.bean.Places
import com.mints.street.main.home.HomeViewModel
import java.lang.ref.WeakReference

object DialogUtils {
    /**
     * 取消开通Vip弹框
     */
    fun showbackvipDialog(ctx: Context, dialogListener: DialogListener) {
        val weakReference = WeakReference<Context>(ctx)
        val bonusDialog = BackVipDialog(weakReference.get()!!, dialogListener)
        bonusDialog.show()
        dialogListener.setDialog(bonusDialog)
    }


    /**
     * 权限设置弹框
     */
    fun showPermissionDialog(ctx: Context, msg: String) {
        val weakReference = WeakReference<Context>(ctx)
        val builder = AlertDialog.Builder(weakReference.get())
        builder.setTitle("提示")
        builder.setMessage("当前应用缺少 " + msg + "授权\n\n请点击 设置-权限-打开所需权限")

        // 拒绝, 退出应用
        builder.setNegativeButton("取消",
                DialogInterface.OnClickListener { dialog, which ->
                })
        builder.setPositiveButton("确定",
                DialogInterface.OnClickListener { dialog, which ->
                    val intent = Intent(
                            Settings.ACTION_APPLICATION_DETAILS_SETTINGS)
                    intent.data = Uri.parse("package:" + weakReference.get()?.getPackageName())
                    weakReference.get()?.startActivity(intent)
                })
        builder.setCancelable(false)
        builder.show()
    }
    /**
     * 打开展示的限时福利弹框
     */
    fun showbennfitsDialog(ctx: Context, viewMode: HomeViewModel, places: List<Places>?) {
        val weakReference = WeakReference<Context>(ctx)
        val bonusDialog = ShowBenfitDialog(weakReference.get()!!,viewMode,places)
        bonusDialog.show()
    }

}