package com.mints.street.widget.dialog

import android.app.Dialog
import android.content.Context
import android.view.Gravity
import android.view.KeyEvent
import android.view.WindowManager
import android.widget.ImageView
import androidx.recyclerview.widget.RecyclerView
import com.alibaba.android.vlayout.DelegateAdapter
import com.alibaba.android.vlayout.VirtualLayoutManager
import com.mints.street.R
import com.mints.street.adapter.GridBenfitViewModel
import com.mints.street.bean.Places
import com.mints.street.main.home.HomeViewModel
import me.goldze.mvvmhabit.utils.RxUtils
import com.mints.street.adapter.GridBenfitAdapter as GridBenfitAdapter

class ShowBenfitDialog(context: Context, val viewMode: HomeViewModel, places: List<Places>?) :
        Dialog(context, R.style.dialog) {

    private val lp: WindowManager.LayoutParams

    private var recycleView: RecyclerView? = null
    private var vLayout: VirtualLayoutManager? = null
    private var mAdapter: DelegateAdapter? = null
    private var gridbenfitAdapter: GridBenfitAdapter? = null
    private var places:List<Places>?=places

    private var iv_close: ImageView?=null
    init {
        setContentView(R.layout.dialog_showbenfit)
        // 设置window属性
        lp = window!!.attributes
        lp.gravity = Gravity.CENTER
        lp.width = WindowManager.LayoutParams.WRAP_CONTENT
        lp.windowAnimations = R.style.DialogAnimBottom
        window!!.attributes = lp

        // 设置外部不可关闭
        setCancelable(false)
        setCanceledOnTouchOutside(false)
        setOnKeyListener { _, i, _ ->
            i == KeyEvent.KEYCODE_BACK
        }
        initView()
    }

    private fun initView() {
        recycleView = findViewById(R.id.recyclerview)
        //recycleView管理（展示套餐推荐）
        vLayout = VirtualLayoutManager(context)
        mAdapter = DelegateAdapter(vLayout, false)
        recycleView?.adapter = mAdapter
        recycleView?.layoutManager = vLayout

        iv_close=findViewById(R.id.iv_close)


        if (gridbenfitAdapter == null){
            //展示 推荐套餐内容
            gridbenfitAdapter= GridBenfitAdapter(context,viewMode,places?.shuffled()?.take(6))
            mAdapter?.addAdapter(gridbenfitAdapter)
        }

        RxUtils.onMultiClick(iv_close){
            dismiss()
        }

//        gridbenfitAdapter?.getPosition() = places!!
        mAdapter?.notifyDataSetChanged()
    }
}