package com.mints.street.widget.dialog

import android.app.Dialog
import android.content.Context
import android.view.Gravity
import android.view.KeyEvent
import android.view.WindowManager
import android.widget.CheckBox
import android.widget.ImageView
import android.widget.TextView
import androidx.appcompat.widget.LinearLayoutCompat
import androidx.recyclerview.widget.RecyclerView
import com.alibaba.android.vlayout.DelegateAdapter
import com.alibaba.android.vlayout.VirtualLayoutManager
import com.google.android.material.bottomsheet.BottomSheetDialog
import com.mints.street.R
import com.mints.street.adapter.GridBenfitAdapter
import com.mints.street.login.LoginActivity
import me.goldze.mvvmhabit.utils.RxUtils
import me.goldze.mvvmhabit.utils.ToastUtils

class ShowLoginDialog(context: Context, private val listener: DialogListener) :
        BottomSheetDialog(context, R.style.dialog) {
    private val lp: WindowManager.LayoutParams

    //弹窗
    private var iv_weixin: ImageView? = null
    private var ly_phone: LinearLayoutCompat? = null
    private var cb_checked: CheckBox? = null
    private var tv_regist: TextView? = null
    private var tv_private: TextView? = null


    init {
        setContentView(R.layout.layout_popupwindow)
        // 设置window属性
        lp = window!!.attributes
        lp.gravity = Gravity.CENTER
        lp.width = WindowManager.LayoutParams.WRAP_CONTENT
        lp.windowAnimations = R.style.DialogAnimBottom
        window!!.attributes = lp

        // 设置外部不可关闭
        setCancelable(true)
        setCanceledOnTouchOutside(false)
        setOnKeyListener { _, i, _ ->
            i == KeyEvent.KEYCODE_BACK
        }
        initView();

        tv_regist?.setOnClickListener {
            listener.onClick(it)
        }
        tv_private?.setOnClickListener {
            listener.onClick(it)
        }
        iv_weixin?.setOnClickListener {
            listener.onClick(it)
        }
        ly_phone?.setOnClickListener {
            listener.onClick(it)
        }
    }

    private fun initView() {
        iv_weixin = findViewById(R.id.iv_weixin)
        ly_phone =findViewById(R.id.ly_phone)
        cb_checked = findViewById(R.id.cb_checked)
        tv_private = findViewById(R.id.tv_private)
        tv_regist = findViewById(R.id.tv_regist)

//                ly_phone?.setOnClickListener(this)
//        RxUtils.onMultiClick(ly_phone) {
//            if (cb_checked!!.isChecked) {
//                startActivity(LoginActivity::class.java)
//                mBottomSheetDialog!!.dismiss()
//            } else {
//                ToastUtils.showShort("请先同意用户协议与隐私政策")
//            }
//        }
    }
}