package com.fry.base.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import com.alibaba.android.vlayout.DelegateAdapter;

import androidx.annotation.NonNull;
import androidx.databinding.ViewDataBinding;

/**
 * @author jeme
 * @date 2019/9/21
 */
public abstract class AbstractVLayoutBaseAdapter<T extends ViewDataBinding,D> extends DelegateAdapter.Adapter<BindingViewHolder<T>> {

    protected Context mContext;
    protected D mData;
    protected int mViewType;
    public AbstractVLayoutBaseAdapter(Context context, D datas, int viewType){
        this.mContext = context;
        this.mData = datas;
        this.mViewType = viewType;
    }
    protected abstract int getLayoutId(int viewType);

    public D getData(){
        return mData;
    }

    @Override
    public int getItemViewType(int position) {
        return mViewType;
    }

    @Override
    public long getItemId(int position) {
        return position;
    }

    @NonNull
    @Override
    public BindingViewHolder<T> onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new BindingViewHolder<>(LayoutInflater.from(mContext).inflate(getLayoutId(viewType), parent, false));
    }
}
