package com.fry.base.base;

import android.content.Context;
import android.os.Build;
import android.webkit.WebView;

import androidx.multidex.MultiDex;

import com.fry.base.config.ModuleLifecycleConfig;
import com.fry.base.thread.WorkTaskManager;

import me.goldze.mvvmhabit.base.BaseApplication;
import me.goldze.mvvmhabit.utils.AppUtils;

import static android.text.TextUtils.isEmpty;

/**
 * Created by jeme on 2019/9/17.
 */
public class BaseApp extends BaseApplication {
    @Override
    public void onCreate() {
        super.onCreate();
        boolean isMainProcess = AppUtils.isMainProcess(this);
        //初始化组件(靠前)
        ModuleLifecycleConfig.getInstance().initModuleAhead(this,isMainProcess);
        //线程管理类
        WorkTaskManager.getInstance().addWorkEventTask(() ->
                ModuleLifecycleConfig.getInstance().initModuleAsWork(BaseApp.this,isMainProcess));
        //....
        //初始化组件(靠后)
        ModuleLifecycleConfig.getInstance().initModuleLow(this,isMainProcess);

    }

    @Override
    protected void attachBaseContext(Context base) {
        super.attachBaseContext(base);
        MultiDex.install(base);
    }

}
