package com.fry.base.base;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.Nullable;
import androidx.databinding.ViewDataBinding;

import me.goldze.mvvmhabit.base.BaseViewModel;
import me.goldze.mvvmhabit.base.HabitBaseFragment;

/**
 * Description : 带缓存的fragment，防止重复初始化造成的问题，（默认关闭，防止埋坑）
 * Created by yue on 2020/4/9
 */

public abstract class BaseCacheFragment<V extends ViewDataBinding, VM extends BaseViewModel> extends HabitBaseFragment<V,VM> {

    protected View cacheView;
    private boolean hasCache;

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        if (cacheView == null || !needCache()) {//如果view没有被初始化或者不需要缓存的情况下，重新初始化控件
            cacheView = super.onCreateView(inflater, container, savedInstanceState);
            hasCache = false;
        } else {
            hasCache = true;
            ViewGroup v = (ViewGroup) cacheView.getParent();
            if (v != null) {
                v.removeView(cacheView);
            }
        }
        return cacheView;
    }

    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState) {
        if (!hasCache) {
            super.onViewCreated(view, savedInstanceState);
        }
    }

    protected boolean needCache() {
        return false;
    }
}
