package com.fry.base.base;

import android.app.Application;
import android.view.Gravity;

import me.goldze.mvvmhabit.utils.KLog;
import me.goldze.mvvmhabit.utils.ToastUtils;
import com.fry.base.BuildConfig;
import com.fry.base.global.Constants;
import com.tencent.bugly.Bugly;
import com.tencent.bugly.crashreport.CrashReport;


/**
 * Created by goldze on 2018/6/21 0021.
 * 基础库自身初始化操作
 */

public class BaseModuleInit implements IModuleInit<Void> {
    @Override
    public boolean onInitAhead(Application application,boolean isMainProcess) {

        //开启打印日志
        KLog.init(BuildConfig.DEBUG);
        //初始化阿里路由框架
//        if (BuildConfig.DEBUG) {
//            ARouter.openLog();     // 打印日志
//            ARouter.openDebug();   // 开启调试模式(如果在InstantRun模式下运行，必须开启调试模式！线上版本需要关闭,否则有安全风险)
//        }
        // 尽可能早，推荐在Application中初始化
       // ARouter.init(application);
        ToastUtils.setGravity(Gravity.CENTER,0,0);

        return false;
    }

    @Override
    public Void runBackground(Application application, boolean isMainProcess) {
        // 这里实现SDK初始化，appId替换成你的在Bugly平台申请的appId
        // 调试时，将第三个参数改为true
            CrashReport.initCrashReport(application, Constants.BUGLY_APP_ID, BuildConfig.IS_DEV);
        return null;
    }

    @Override
    public void runMainAfterBackground(Application application, boolean isMainProcess, Void result) {

    }

    @Override
    public boolean onInitLow(Application application,boolean isMainProcess) {
        return false;
    }
}
