package com.fry.base.base;

import android.app.Application;

/**
 * Created by goldze on 2018/6/21 0021.
 * 动态配置Application，有需要初始化的组件实现该接口，统一在主app的Application中初始化
 */

public interface IModuleInit<T> {
    //

    /***
     * 初始化优先的
     * @param isMainProcess 是否主进程
     */
    boolean onInitAhead(Application application,boolean isMainProcess);

    /***
     * 运行在后台线程
     * @param isMainProcess 是否主进程
     */
    T runBackground(Application application,boolean isMainProcess);

    /***
     * 执行在runBackground方法之后
     * @param isMainProcess 是否主进程
     * @param result runBackground 方法的返回结果
     */
    void runMainAfterBackground(Application application,boolean isMainProcess,T result);

    /***
     * 初始化靠后的
     * @param isMainProcess 是否主进程
     */
    boolean onInitLow(Application application,boolean isMainProcess);
}
