package com.fry.base.binding

import android.view.View
import android.view.ViewGroup
import androidx.databinding.BindingAdapter
import com.fry.base.expand.Margin
import com.fry.base.expand.Padding
import com.fry.base.expand.ViewStyle

/**
 * 2020/7/19 created
 * @author KOM
 */

@BindingAdapter(
        "paddingStart",
        "paddingTop",
        "paddingEnd",
        "paddingBottom",
        "paddingHorizontal",
        "paddingVertical",
        "padding",
        requireAll = false
)
fun View.setPadding(
        left: Int?,
        top: Int?,
        right: Int?,
        bottom: Int?,
        horizontal: Int?,
        vertical: Int?,
        all: Int?
) {
    ViewStyle<View>(padding = Padding(
            left ?: horizontal ?: all ?: paddingStart,
            top ?: vertical ?: all ?: paddingTop,
            right ?: horizontal ?: all ?: paddingEnd,
            bottom ?: vertical ?: all ?: paddingBottom
    ))(this)
}


@BindingAdapter(
        "marginStart",
        "marginTop",
        "marginEnd",
        "marginBottom",
        "marginHorizontal",
        "marginVertical",
        "margin",
        requireAll = false
)
fun View.setMargin(
        left: Int?,
        top: Int?,
        right: Int?,
        bottom: Int?,
        horizontal: Int?,
        vertical: Int?,
        all: Int?
) {
    if (layoutParams is ViewGroup.MarginLayoutParams) {
        with(layoutParams as ViewGroup.MarginLayoutParams){
            ViewStyle<View>(margin = Margin(
                    left ?: horizontal ?: all ?: marginStart,
                    top ?: vertical ?: all ?: topMargin,
                    right ?: horizontal ?: all ?: marginEnd,
                    bottom ?: vertical ?: all ?: bottomMargin
            ))(this@setMargin)
        }
    }
}