package com.fry.base.ui.widget

import android.content.Context
import android.util.AttributeSet
import android.view.View
import android.widget.HorizontalScrollView

/**
 * Description :
 * Created by yue on 2020/6/11
 */
class HorizontalScrollView (context: Context, attributeSet: AttributeSet): HorizontalScrollView(context, attributeSet) {

    private var mListener: ((view: View, scrollX: Int, scrollY: Int, oldScrollX: Int, oldScrollY: Int) -> Unit)? = null

    fun setOnScrollChangeListener(mListener: ((view: View, scrollX: Int, scrollY: Int, oldScrollX: Int, oldScrollY: Int) -> Unit)) {
        this.mListener = mListener
    }
    override fun onScrollChanged(l: Int, t: Int, oldl: Int, oldt: Int) {
        super.onScrollChanged(l, t, oldl, oldt)
        if (mListener != null) {
            mListener!!(this, l, t, oldl, oldt)
        }
    }
}