package com.fry.base.ui.widget;

import android.content.Context;
import android.content.res.TypedArray;
import android.util.AttributeSet;

import androidx.annotation.Nullable;

import com.fry.base.R;

/**
 * 2019-12-10 created
 * 设置内容最大高度
 *
 * @author KOM
 */
public class MaxHeightRecyclerView extends CustomRecycleView {
    private int mMaxHeight = -1;

    public MaxHeightRecyclerView(Context context) {
        this(context, null);
    }

    public MaxHeightRecyclerView(Context context, @Nullable AttributeSet attrs) {
        this(context, attrs, 0);
    }

    public MaxHeightRecyclerView(Context context, @Nullable AttributeSet attrs, int defStyle) {
        super(context, attrs, defStyle);

        TypedArray typedArray = context.obtainStyledAttributes(attrs, R.styleable.MaxHeightRecyclerView);
        mMaxHeight = typedArray.getDimensionPixelOffset(R.styleable.MaxHeightRecyclerView_rv_maxHeight, mMaxHeight);
        typedArray.recycle();
    }

    @Override
    protected void onMeasure(int widthSpec, int heightSpec) {
        if (mMaxHeight > -1) {
            heightSpec = MeasureSpec.makeMeasureSpec(mMaxHeight,
                    MeasureSpec.AT_MOST);
        }
        super.onMeasure(widthSpec, heightSpec);
    }
}
