package com.fry.base.utils;

/**
 * 2019-11-28 created
 *
 * @author KOM
 */
import android.view.View;

public abstract class OnSingleClickListener implements View.OnClickListener {
    //单击判断生效时间，以此时间判断生效
    private static final long INTERVAL_CLICK_TIME = 500;
    //上次点击的时间
    private static long lastClickTime = 0;

    @Override
    public final void onClick(View view) {
        if (System.currentTimeMillis() - lastClickTime > getIntervalClickTime()) {
            lastClickTime = System.currentTimeMillis();
            onSingleClick(view);
        }
    }

    /**
     * 处理点击事件
     */
    public abstract void onSingleClick(View v);

    protected long getIntervalClickTime() {
        return INTERVAL_CLICK_TIME;
    }

}

