@file:JvmName("APPThirdPartyUtils")

package com.fry.base.utils

import android.content.Context
import android.content.Intent
import android.content.pm.PackageInfo
import android.content.pm.PackageManager
import android.net.Uri
import me.goldze.mvvmhabit.utils.ToastUtils

/**
 * 2020-01-08 created
 * 第三方APP工具类
 * @author KOM
 */
enum class APPThird(var cnName: String, var packageName: String) {

    /**
     * 微信
     */
    WX("微信", "com.tencent.mm");
}

/**
 * 检查手机上是否安装了指定的软件
 * @param context
 * @param packageName 应用包名
 */
fun isAvailable(context: Context, packageName: String): Boolean {
    //获取packagemanager
    val packageManager: PackageManager = context.packageManager
    //获取所有已安装程序的包信息
    val packageInfos: List<PackageInfo>? = packageManager.getInstalledPackages(0)
    val packageNames: MutableList<String> = mutableListOf()
    packageInfos?.apply {
        packageInfos.forEach { packageInfo ->
            packageNames.add(packageInfo.packageName)
//            KLog.d("packageName: ${packageInfo.packageName}")
        }
    }
    //判断packageNames中是否有目标程序的包名，有TRUE，没有FALSE
    return packageNames.contains(packageName)
}



