@file:JvmName("ViewClick")
package com.fry.base.utils

import android.view.View
import java.lang.Exception

/**
 * 2019-09-27 created
 *
 * @author KOM
 */
fun <T : View> T.onClick(block: (T) -> Unit) = setOnClickListener {
    block(it as T)
}


fun <T : View> T.onClickSingle(block: (T) -> Unit) = setOnClickListener(
        object : OnSingleClickListener() {
            override fun onSingleClick(v: View?) {
                block(this@onClickSingle)
            }
        })

fun <T> tryDef(def: T, block: () -> T): T {
    return try {
        block()
    } catch (e: Exception) {
        e.printStackTrace()
        def
    }
}