package com.fry.base.utils.helper;

import android.view.View;
import android.widget.LinearLayout;

/**
 * Description : LinearLayout简单布局工具
 * Created by yue on 2020/7/31
 */
public class LinearFillingHelper {

    private Adapter adapter;
    private LinearLayout linearLayout;

    public void setAdapter(LinearLayout linearLayout, Adapter adapter) {
        this.adapter = adapter;
        this.linearLayout = linearLayout;
        adapter.injectionFillingHelper(this);
        fillLayout();
    }

    private void fillLayout() {
        linearLayout.removeAllViews();
        for (int i = 0; i < adapter.getItemCount(); i++) {
            View child = View.inflate(linearLayout.getContext(), adapter.getLayoutId(), null);
            linearLayout.addView(child);
            adapter.bindView(child, i);
        }
    }

    private void notifyLayout() {
        if (linearLayout.getChildCount() != adapter.getItemCount()) {
            fillLayout();
            return;
        }
        for (int i = 0; i < linearLayout.getChildCount(); i++) {
            View child = linearLayout.getChildAt(i);
            adapter.bindView(child, i);
        }
    }

    public static abstract class Adapter {

        public abstract int getItemCount();

        public abstract int getLayoutId();

        public abstract void bindView(View contentView, int position);

        private LinearFillingHelper fillingHelper;

        public final void injectionFillingHelper(LinearFillingHelper fillingHelper) {
            this.fillingHelper = fillingHelper;
        }

        public void notifyDataSetChanged() {
            fillingHelper.notifyLayout();
        }
    }
}
