package com.fry.base.viewmodel;

import android.app.Application;


import com.fry.base.bean.PageBean;

import androidx.annotation.NonNull;
import androidx.lifecycle.MutableLiveData;
import me.goldze.mvvmhabit.binding.command.BindingCommand;

/**
 * @author jeme
 * @date 2019/10/14
 */
public class LoadMoreViewModel extends RefreshViewModel {
    protected int page = 1;
    public MutableLiveData<Boolean> hasMore = new MutableLiveData<>();
    public LoadMoreViewModel(@NonNull Application application) {
        super(application);
        hasMore.setValue(true);
    }

    public boolean isRefresh(){
        return page == 1;
    }

    public BindingCommand onLoadMoreCommand = new BindingCommand(()->{
        if(hasMore.getValue()) {
            page++;
            requestData(false);
        }else{
//            ToastUtils.showShort("仓主，没有更多了");
            dismissDialog();
        }
    });

    @Override
    public void requestData() {
        page = 1;
        requestData(true);
    }

    protected void requestData(boolean isRefresh){}

    protected void hasMoreData(PageBean pageInfo){
        if (pageInfo == null){
            hasMore.setValue(true);
        }else{
            hasMore.setValue(pageInfo.getPageNum() * pageInfo.getPageSize() < pageInfo.getTotal());
            page = pageInfo.getPageNum();
        }
      /*  if(page == 1){
            hasMore.setValue(true);
        }else{
            if(data == null || data.size() == 0){
                hasMore.setValue(false);
            }else{
                hasMore.setValue(true);
            }
        }*/
    }

    public int getPage(){
        return page;
    }

}
