package me.goldze.mvvmhabit.dialog

import android.content.Context
import android.text.InputFilter
import android.text.InputType
import android.view.View
import com.lxj.xpopup.core.CenterPopupView
import com.lxj.xpopup.interfaces.OnInputConfirmListener
import kotlinx.android.synthetic.main.dialog_input_layout.view.*
import me.goldze.mvvmhabit.R


/**
 *
 * @author jeme
 * @date 2020/3/7
 */
class InputDialog(context: Context,val title : String = "",
                  val content : String? ="",
                  val hint : String="",
                  val confirm : String = "确认",
                  val listener: OnInputConfirmListener?) : CenterPopupView(context) {

    var defaultInputType = InputType.TYPE_CLASS_TEXT
    var defaultMaxLength = Int.MAX_VALUE

    override fun getImplLayoutId() = R.layout.dialog_input_layout
    override fun onCreate() {
        super.onCreate()
        if (title == ""){
            tv_title.visibility = View.GONE
        }else{
            tv_title.visibility = View.VISIBLE
            tv_title.text = title
        }
        et_input.hint = hint
        et_input.inputType = defaultInputType
        et_input.setText(content)
        et_input.setSelection(content?.length?:0)
        val filters: Array<InputFilter> = arrayOf<InputFilter>(InputFilter.LengthFilter(defaultMaxLength))
        et_input.filters = filters
        tv_confirm.text = confirm
        tv_confirm.setOnClickListener {
            listener?.onConfirm(et_input.text.toString())
        }
        tv_cancel.setOnClickListener {
            dismiss()
        }
    }

    /***
     * @link (InputType.)
     */
    fun setInputType(inputType : Int){
        defaultInputType = inputType
        et_input?.apply {
            this.inputType = inputType
        }
    }
    fun setInputLength(length : Int){
        defaultMaxLength = length
    }
}