package me.goldze.mvvmhabit.utils

import android.content.Context
import com.lxj.xpopup.XPopup
import com.lxj.xpopup.core.BottomPopupView
import kotlinx.android.synthetic.main.dialog_select.view.*
import me.goldze.mvvmhabit.R

/**
 * @author 冯瑞雨
 * @date 2020/3/25 16:29
 */
class CommonSelectDialog(var mContext: Context,val nameOne:String,val nameTwo:String,val onItemClick:OnItemClick) : BottomPopupView(mContext) {

    var isRefresh = true

    companion object {
        @JvmStatic
        fun showDialog(context: Context,nameOne:String,nameTwo:String, onItemClick:OnItemClick): CommonSelectDialog {
            return XPopup.Builder(context)
                    .asCustom(CommonSelectDialog(context,nameOne,nameTwo, onItemClick))
                    .show() as CommonSelectDialog
        }

    }

    override fun getImplLayoutId() = R.layout.dialog_select

    override fun onCreate() {
        tv_one.text = nameOne
        tv_two.text = nameTwo
        RxUtils.onMultiClick(tv_one){
            onItemClick.let {
                onItemClick.tvOne()
                isRefresh = false
            }
            this.dismiss()
        }
        RxUtils.onMultiClick(tv_two){
            onItemClick.let {
                isRefresh = false
                onItemClick.tvTwo()
            }
            this.dismiss()
        }
        RxUtils.onMultiClick(tv_cancel){
            this.dismiss()
        }


    }

    override fun onDismiss() {
        super.onDismiss()
        if (isRefresh){
            onItemClick.let {
                onItemClick.cancel()
            }
        }

    }
    interface OnItemClick{
        fun tvOne()
        fun tvTwo()
        fun cancel()
    }

}